/* sudoku-game.c generated by valac 0.46.0, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define TYPE_SUDOKU_GAME (sudoku_game_get_type ())
#define SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_GAME, SudokuGame))
#define SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_GAME, SudokuGameClass))
#define IS_SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_GAME))
#define IS_SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_GAME))
#define SUDOKU_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_GAME, SudokuGameClass))

typedef struct _SudokuGame SudokuGame;
typedef struct _SudokuGameClass SudokuGameClass;
typedef struct _SudokuGamePrivate SudokuGamePrivate;

#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;
typedef enum  {
	GAME_MODE_PLAY,
	GAME_MODE_CREATE
} GameMode;

#define TYPE_GAME_MODE (game_mode_get_type ())

#define SUDOKU_GAME_TYPE_UNDO_ITEM (sudoku_game_undo_item_get_type ())
typedef struct _SudokuGameUndoItem SudokuGameUndoItem;
enum  {
	SUDOKU_GAME_0_PROPERTY,
	SUDOKU_GAME_PAUSED_PROPERTY,
	SUDOKU_GAME_NUM_PROPERTIES
};
static GParamSpec* sudoku_game_properties[SUDOKU_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;
#define _sudoku_game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_undo_item_free (var), NULL)))
enum  {
	SUDOKU_GAME_TICK_SIGNAL,
	SUDOKU_GAME_PAUSED_CHANGED_SIGNAL,
	SUDOKU_GAME_CELL_CHANGED_SIGNAL,
	SUDOKU_GAME_NUM_SIGNALS
};
static guint sudoku_game_signals[SUDOKU_GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuGame {
	GObject parent_instance;
	SudokuGamePrivate * priv;
	SudokuBoard* board;
	GameMode mode;
	GTimer* timer;
};

struct _SudokuGameClass {
	GObjectClass parent_class;
};

struct _SudokuGameUndoItem {
	gint row;
	gint col;
	gint val;
	gboolean* earmarks;
	gint earmarks_length1;
	gint _earmarks_size_;
};

struct _SudokuGamePrivate {
	guint clock_timeout;
	gboolean _paused;
	GeeList* undostack;
	GeeList* redostack;
};

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};

static gint SudokuGame_private_offset;
static gpointer sudoku_game_parent_class = NULL;

GType sudoku_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuGame, g_object_unref)
GType sudoku_board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuBoard, g_object_unref)
GType game_mode_get_type (void) G_GNUC_CONST;
static GType sudoku_game_undo_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self);
static void sudoku_game_undo_item_free (SudokuGameUndoItem* self);
static void sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                                 SudokuGameUndoItem* dest);
static void sudoku_game_undo_item_destroy (SudokuGameUndoItem* self);
gboolean sudoku_game_is_undostack_null (SudokuGame* self);
gboolean sudoku_game_is_redostack_null (SudokuGame* self);
SudokuGame* sudoku_game_new (SudokuBoard* board);
SudokuGame* sudoku_game_construct (GType object_type,
                                   SudokuBoard* board);
void sudoku_game_enable_earmark (SudokuGame* self,
                                 gint row,
                                 gint col,
                                 gint k_no);
gint sudoku_board_get (SudokuBoard* self,
                       gint row,
                       gint col);
gboolean* sudoku_board_get_earmarks (SudokuBoard* self,
                                     gint row,
                                     gint col,
                                     gint* result_length1);
void sudoku_game_update_undo (SudokuGame* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gboolean* old_earmarks,
                              gint old_earmarks_length1);
void sudoku_board_enable_earmark (SudokuBoard* self,
                                  gint row,
                                  gint column,
                                  gint digit);
void sudoku_game_disable_earmark (SudokuGame* self,
                                  gint row,
                                  gint col,
                                  gint k_no);
void sudoku_board_disable_earmark (SudokuBoard* self,
                                   gint row,
                                   gint column,
                                   gint digit);
void sudoku_game_insert (SudokuGame* self,
                         gint row,
                         gint col,
                         gint val);
void sudoku_board_insert (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val,
                          gboolean is_fixed);
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
void sudoku_game_remove (SudokuGame* self,
                         gint row,
                         gint col);
void sudoku_board_remove (SudokuBoard* self,
                          gint row,
                          gint col,
                          gboolean is_fixed);
gboolean sudoku_game_is_empty (SudokuGame* self);
gint sudoku_board_get_filled (SudokuBoard* self);
gboolean sudoku_board_is_empty (SudokuBoard* self);
void sudoku_game_undo (SudokuGame* self);
static void sudoku_game_apply_stack (SudokuGame* self,
                              GeeList* from,
                              GeeList* to);
void sudoku_game_redo (SudokuGame* self);
void sudoku_game_reset (SudokuGame* self);
void sudoku_board_set_previous_played_time (SudokuBoard* self,
                                            gdouble value);
gint sudoku_board_get_rows (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
void sudoku_game_cell_changed_cb (SudokuGame* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void sudoku_game_add_to_stack (SudokuGame* self,
                               GeeList* stack,
                               gint r,
                               gint c,
                               gint v,
                               gboolean* e,
                               gint e_length1);
static gboolean* _vala_array_dup9 (gboolean* self,
                            int length);
gdouble sudoku_game_get_total_time_played (SudokuGame* self);
gdouble sudoku_board_get_previous_played_time (SudokuBoard* self);
static gboolean sudoku_game_timeout_cb (SudokuGame* self);
static gboolean _sudoku_game_timeout_cb_gsource_func (gpointer self);
void sudoku_game_start_clock (SudokuGame* self);
void sudoku_game_stop_clock (SudokuGame* self);
static void sudoku_game_set_paused (SudokuGame* self,
                             gboolean value);
void sudoku_game_resume_clock (SudokuGame* self);
gboolean sudoku_game_get_paused (SudokuGame* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean* _vala_array_dup10 (gboolean* self,
                             int length);
static void sudoku_game_finalize (GObject * obj);
static void _vala_sudoku_game_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_game_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
sudoku_game_get_instance_private (SudokuGame* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuGame_private_offset);
}

gboolean
sudoku_game_is_undostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result = FALSE;
#line 58 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 60 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 60 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 60 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 60 "../lib/sudoku-game.vala"
	return result;
#line 285 "sudoku-game.c"
}

gboolean
sudoku_game_is_redostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result = FALSE;
#line 63 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 65 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 65 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 65 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 65 "../lib/sudoku-game.vala"
	return result;
#line 307 "sudoku-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../lib/sudoku-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 315 "sudoku-game.c"
}

SudokuGame*
sudoku_game_construct (GType object_type,
                       SudokuBoard* board)
{
	SudokuGame * self = NULL;
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 68 "../lib/sudoku-game.vala"
	g_return_val_if_fail (board != NULL, NULL);
#line 68 "../lib/sudoku-game.vala"
	self = (SudokuGame*) g_object_new (object_type, NULL);
#line 70 "../lib/sudoku-game.vala"
	_tmp0_ = _g_object_ref0 (board);
#line 70 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->board);
#line 70 "../lib/sudoku-game.vala"
	self->board = _tmp0_;
#line 71 "../lib/sudoku-game.vala"
	self->mode = GAME_MODE_PLAY;
#line 72 "../lib/sudoku-game.vala"
	_tmp1_ = g_timer_new ();
#line 72 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->timer);
#line 72 "../lib/sudoku-game.vala"
	self->timer = _tmp1_;
#line 73 "../lib/sudoku-game.vala"
	_tmp2_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 73 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 73 "../lib/sudoku-game.vala"
	self->priv->undostack = (GeeList*) _tmp2_;
#line 74 "../lib/sudoku-game.vala"
	_tmp3_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 74 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 74 "../lib/sudoku-game.vala"
	self->priv->redostack = (GeeList*) _tmp3_;
#line 68 "../lib/sudoku-game.vala"
	return self;
#line 359 "sudoku-game.c"
}

SudokuGame*
sudoku_game_new (SudokuBoard* board)
{
#line 68 "../lib/sudoku-game.vala"
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
#line 367 "sudoku-game.c"
}

void
sudoku_game_enable_earmark (SudokuGame* self,
                            gint row,
                            gint col,
                            gint k_no)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 77 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 79 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 79 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 80 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 80 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 80 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 80 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 80 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 81 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 83 "../lib/sudoku-game.vala"
	_tmp4_ = self->board;
#line 83 "../lib/sudoku-game.vala"
	sudoku_board_enable_earmark (_tmp4_, row, col, k_no);
#line 77 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 409 "sudoku-game.c"
}

void
sudoku_game_disable_earmark (SudokuGame* self,
                             gint row,
                             gint col,
                             gint k_no)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 86 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 88 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 88 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 89 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 89 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 89 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 89 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 89 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 90 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 92 "../lib/sudoku-game.vala"
	_tmp4_ = self->board;
#line 92 "../lib/sudoku-game.vala"
	sudoku_board_disable_earmark (_tmp4_, row, col, k_no);
#line 86 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 451 "sudoku-game.c"
}

void
sudoku_game_insert (SudokuGame* self,
                    gint row,
                    gint col,
                    gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	GameMode _tmp5_;
#line 95 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 97 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 97 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 98 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 98 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 98 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 98 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 98 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 99 "../lib/sudoku-game.vala"
	_tmp4_ = old_earmarks;
#line 99 "../lib/sudoku-game.vala"
	_tmp4__length1 = old_earmarks_length1;
#line 99 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, _tmp4_, (gint) _tmp4__length1);
#line 101 "../lib/sudoku-game.vala"
	_tmp5_ = self->mode;
#line 101 "../lib/sudoku-game.vala"
	if (_tmp5_ == GAME_MODE_CREATE) {
#line 497 "sudoku-game.c"
		SudokuBoard* _tmp6_;
		SudokuBoard* _tmp7_;
		gboolean* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
#line 103 "../lib/sudoku-game.vala"
		_tmp6_ = self->board;
#line 103 "../lib/sudoku-game.vala"
		sudoku_board_insert (_tmp6_, row, col, val, TRUE);
#line 104 "../lib/sudoku-game.vala"
		_tmp7_ = self->board;
#line 104 "../lib/sudoku-game.vala"
		_tmp8_ = _tmp7_->is_fixed;
#line 104 "../lib/sudoku-game.vala"
		_tmp8__length1 = _tmp7_->is_fixed_length1;
#line 104 "../lib/sudoku-game.vala"
		_tmp8__length2 = _tmp7_->is_fixed_length2;
#line 104 "../lib/sudoku-game.vala"
		_tmp8_[(row * _tmp8__length2) + col] = TRUE;
#line 517 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp9_;
#line 107 "../lib/sudoku-game.vala"
		_tmp9_ = self->board;
#line 107 "../lib/sudoku-game.vala"
		sudoku_board_insert (_tmp9_, row, col, val, FALSE);
#line 524 "sudoku-game.c"
	}
#line 109 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, val);
#line 95 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 530 "sudoku-game.c"
}

void
sudoku_game_remove (SudokuGame* self,
                    gint row,
                    gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	GameMode _tmp5_;
#line 112 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 114 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 114 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 115 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 115 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 115 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 115 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 115 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 116 "../lib/sudoku-game.vala"
	_tmp4_ = old_earmarks;
#line 116 "../lib/sudoku-game.vala"
	_tmp4__length1 = old_earmarks_length1;
#line 116 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, _tmp4_, (gint) _tmp4__length1);
#line 118 "../lib/sudoku-game.vala"
	_tmp5_ = self->mode;
#line 118 "../lib/sudoku-game.vala"
	if (_tmp5_ == GAME_MODE_CREATE) {
#line 575 "sudoku-game.c"
		SudokuBoard* _tmp6_;
		SudokuBoard* _tmp7_;
		gboolean* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
#line 120 "../lib/sudoku-game.vala"
		_tmp6_ = self->board;
#line 120 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp6_, row, col, TRUE);
#line 121 "../lib/sudoku-game.vala"
		_tmp7_ = self->board;
#line 121 "../lib/sudoku-game.vala"
		_tmp8_ = _tmp7_->is_fixed;
#line 121 "../lib/sudoku-game.vala"
		_tmp8__length1 = _tmp7_->is_fixed_length1;
#line 121 "../lib/sudoku-game.vala"
		_tmp8__length2 = _tmp7_->is_fixed_length2;
#line 121 "../lib/sudoku-game.vala"
		_tmp8_[(row * _tmp8__length2) + col] = FALSE;
#line 595 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp9_;
#line 124 "../lib/sudoku-game.vala"
		_tmp9_ = self->board;
#line 124 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp9_, row, col, FALSE);
#line 602 "sudoku-game.c"
	}
#line 126 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, 0);
#line 112 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 608 "sudoku-game.c"
}

gboolean
sudoku_game_is_empty (SudokuGame* self)
{
	GameMode _tmp0_;
	gboolean result = FALSE;
#line 129 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../lib/sudoku-game.vala"
	_tmp0_ = self->mode;
#line 131 "../lib/sudoku-game.vala"
	if (_tmp0_ == GAME_MODE_CREATE) {
#line 622 "sudoku-game.c"
		SudokuBoard* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 132 "../lib/sudoku-game.vala"
		_tmp1_ = self->board;
#line 132 "../lib/sudoku-game.vala"
		_tmp2_ = sudoku_board_get_filled (_tmp1_);
#line 132 "../lib/sudoku-game.vala"
		_tmp3_ = _tmp2_;
#line 132 "../lib/sudoku-game.vala"
		result = _tmp3_ == 0;
#line 132 "../lib/sudoku-game.vala"
		return result;
#line 636 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp4_;
#line 134 "../lib/sudoku-game.vala"
		_tmp4_ = self->board;
#line 134 "../lib/sudoku-game.vala"
		result = sudoku_board_is_empty (_tmp4_);
#line 134 "../lib/sudoku-game.vala"
		return result;
#line 645 "sudoku-game.c"
	}
}

void
sudoku_game_undo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 137 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 139 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 139 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 139 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 662 "sudoku-game.c"
}

void
sudoku_game_redo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 142 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 144 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 144 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->undostack;
#line 144 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 678 "sudoku-game.c"
}

void
sudoku_game_reset (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	SudokuBoard* _tmp26_;
	GeeSet* _tmp27_;
#line 147 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 149 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 149 "../lib/sudoku-game.vala"
	sudoku_board_set_previous_played_time (_tmp0_, (gdouble) 0);
#line 150 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 150 "../lib/sudoku-game.vala"
	g_timer_start (_tmp1_);
#line 151 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->undostack;
#line 151 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp2_);
#line 152 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->redostack;
#line 152 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp3_);
#line 708 "sudoku-game.c"
	{
		gint l1 = 0;
#line 153 "../lib/sudoku-game.vala"
		l1 = 0;
#line 713 "sudoku-game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 153 "../lib/sudoku-game.vala"
			_tmp4_ = TRUE;
#line 153 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 720 "sudoku-game.c"
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 153 "../lib/sudoku-game.vala"
				if (!_tmp4_) {
#line 726 "sudoku-game.c"
					gint _tmp5_;
#line 153 "../lib/sudoku-game.vala"
					_tmp5_ = l1;
#line 153 "../lib/sudoku-game.vala"
					l1 = _tmp5_ + 1;
#line 732 "sudoku-game.c"
				}
#line 153 "../lib/sudoku-game.vala"
				_tmp4_ = FALSE;
#line 153 "../lib/sudoku-game.vala"
				_tmp6_ = self->board;
#line 153 "../lib/sudoku-game.vala"
				_tmp7_ = sudoku_board_get_rows (_tmp6_);
#line 153 "../lib/sudoku-game.vala"
				_tmp8_ = _tmp7_;
#line 153 "../lib/sudoku-game.vala"
				if (!(l1 < _tmp8_)) {
#line 153 "../lib/sudoku-game.vala"
					break;
#line 746 "sudoku-game.c"
				}
				{
					gint l2 = 0;
#line 155 "../lib/sudoku-game.vala"
					l2 = 0;
#line 752 "sudoku-game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 155 "../lib/sudoku-game.vala"
						_tmp9_ = TRUE;
#line 155 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 759 "sudoku-game.c"
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gboolean _tmp14_ = FALSE;
							GameMode _tmp15_;
							SudokuBoard* _tmp19_;
							SudokuBoard* _tmp20_;
							gboolean* _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							gboolean _tmp22_;
							SudokuBoard* _tmp23_;
							gboolean* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							SudokuBoard* _tmp25_;
#line 155 "../lib/sudoku-game.vala"
							if (!_tmp9_) {
#line 778 "sudoku-game.c"
								gint _tmp10_;
#line 155 "../lib/sudoku-game.vala"
								_tmp10_ = l2;
#line 155 "../lib/sudoku-game.vala"
								l2 = _tmp10_ + 1;
#line 784 "sudoku-game.c"
							}
#line 155 "../lib/sudoku-game.vala"
							_tmp9_ = FALSE;
#line 155 "../lib/sudoku-game.vala"
							_tmp11_ = self->board;
#line 155 "../lib/sudoku-game.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 155 "../lib/sudoku-game.vala"
							_tmp13_ = _tmp12_;
#line 155 "../lib/sudoku-game.vala"
							if (!(l2 < _tmp13_)) {
#line 155 "../lib/sudoku-game.vala"
								break;
#line 798 "sudoku-game.c"
							}
#line 157 "../lib/sudoku-game.vala"
							_tmp15_ = self->mode;
#line 157 "../lib/sudoku-game.vala"
							if (_tmp15_ == GAME_MODE_PLAY) {
#line 804 "sudoku-game.c"
								SudokuBoard* _tmp16_;
								gboolean* _tmp17_;
								gint _tmp17__length1;
								gint _tmp17__length2;
								gboolean _tmp18_;
#line 157 "../lib/sudoku-game.vala"
								_tmp16_ = self->board;
#line 157 "../lib/sudoku-game.vala"
								_tmp17_ = _tmp16_->is_fixed;
#line 157 "../lib/sudoku-game.vala"
								_tmp17__length1 = _tmp16_->is_fixed_length1;
#line 157 "../lib/sudoku-game.vala"
								_tmp17__length2 = _tmp16_->is_fixed_length2;
#line 157 "../lib/sudoku-game.vala"
								_tmp18_ = _tmp17_[(l1 * _tmp17__length2) + l2];
#line 157 "../lib/sudoku-game.vala"
								_tmp14_ = _tmp18_;
#line 822 "sudoku-game.c"
							} else {
#line 157 "../lib/sudoku-game.vala"
								_tmp14_ = FALSE;
#line 826 "sudoku-game.c"
							}
#line 157 "../lib/sudoku-game.vala"
							if (_tmp14_) {
#line 158 "../lib/sudoku-game.vala"
								continue;
#line 832 "sudoku-game.c"
							}
#line 160 "../lib/sudoku-game.vala"
							_tmp19_ = self->board;
#line 160 "../lib/sudoku-game.vala"
							_tmp20_ = self->board;
#line 160 "../lib/sudoku-game.vala"
							_tmp21_ = _tmp20_->is_fixed;
#line 160 "../lib/sudoku-game.vala"
							_tmp21__length1 = _tmp20_->is_fixed_length1;
#line 160 "../lib/sudoku-game.vala"
							_tmp21__length2 = _tmp20_->is_fixed_length2;
#line 160 "../lib/sudoku-game.vala"
							_tmp22_ = _tmp21_[(l1 * _tmp21__length2) + l2];
#line 160 "../lib/sudoku-game.vala"
							sudoku_board_remove (_tmp19_, l1, l2, _tmp22_);
#line 161 "../lib/sudoku-game.vala"
							_tmp23_ = self->board;
#line 161 "../lib/sudoku-game.vala"
							_tmp24_ = _tmp23_->is_fixed;
#line 161 "../lib/sudoku-game.vala"
							_tmp24__length1 = _tmp23_->is_fixed_length1;
#line 161 "../lib/sudoku-game.vala"
							_tmp24__length2 = _tmp23_->is_fixed_length2;
#line 161 "../lib/sudoku-game.vala"
							_tmp24_[(l1 * _tmp24__length2) + l2] = FALSE;
#line 162 "../lib/sudoku-game.vala"
							_tmp25_ = self->board;
#line 162 "../lib/sudoku-game.vala"
							g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, l1, l2, sudoku_board_get (_tmp25_, l1, l2), 0);
#line 862 "sudoku-game.c"
						}
					}
				}
			}
		}
	}
#line 165 "../lib/sudoku-game.vala"
	_tmp26_ = self->board;
#line 165 "../lib/sudoku-game.vala"
	_tmp27_ = _tmp26_->broken_coords;
#line 165 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp27_);
#line 875 "sudoku-game.c"
}

void
sudoku_game_cell_changed_cb (SudokuGame* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
#line 168 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 170 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, new_val);
#line 889 "sudoku-game.c"
}

void
sudoku_game_update_undo (SudokuGame* self,
                         gint row,
                         gint col,
                         gint old_val,
                         gboolean* old_earmarks,
                         gint old_earmarks_length1)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 173 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 175 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 175 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp0_, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 176 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 176 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp1_);
#line 912 "sudoku-game.c"
}

static gboolean*
_vala_array_dup9 (gboolean* self,
                  int length)
{
#line 181 "../lib/sudoku-game.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 921 "sudoku-game.c"
}

static void
sudoku_game_add_to_stack (SudokuGame* self,
                          GeeList* stack,
                          gint r,
                          gint c,
                          gint v,
                          gboolean* e,
                          gint e_length1)
{
	SudokuGameUndoItem step = {0};
	gboolean* _tmp0_;
	gint _tmp0__length1;
	SudokuGameUndoItem _tmp1_ = {0};
	SudokuGameUndoItem _tmp2_;
#line 179 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 179 "../lib/sudoku-game.vala"
	g_return_if_fail (stack != NULL);
#line 181 "../lib/sudoku-game.vala"
	_tmp0_ = (e != NULL) ? _vala_array_dup9 (e, e_length1) : ((gpointer) e);
#line 181 "../lib/sudoku-game.vala"
	_tmp0__length1 = e_length1;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.row = r;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.col = c;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.val = v;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = (g_free (_tmp1_.earmarks), NULL);
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = _tmp0_;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_.earmarks_length1 = _tmp0__length1;
#line 181 "../lib/sudoku-game.vala"
	_tmp1_._earmarks_size_ = _tmp1_.earmarks_length1;
#line 181 "../lib/sudoku-game.vala"
	step = _tmp1_;
#line 182 "../lib/sudoku-game.vala"
	_tmp2_ = step;
#line 182 "../lib/sudoku-game.vala"
	gee_collection_add ((GeeCollection*) stack, &_tmp2_);
#line 179 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (&step);
#line 968 "sudoku-game.c"
}

static void
sudoku_game_apply_stack (SudokuGame* self,
                         GeeList* from,
                         GeeList* to)
{
	gint _tmp0_;
	gint _tmp1_;
	SudokuGameUndoItem* top = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	gint old_val = 0;
	SudokuBoard* _tmp5_;
	SudokuGameUndoItem* _tmp6_;
	SudokuGameUndoItem* _tmp7_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp8_;
	SudokuGameUndoItem* _tmp9_;
	SudokuGameUndoItem* _tmp10_;
	gint _tmp11_ = 0;
	gboolean* _tmp12_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuGameUndoItem* _tmp13_;
	SudokuGameUndoItem* _tmp14_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	GameMode _tmp16_;
	SudokuGameUndoItem* _tmp32_;
	SudokuGameUndoItem* _tmp64_;
	SudokuGameUndoItem* _tmp65_;
	SudokuGameUndoItem* _tmp66_;
#line 185 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 185 "../lib/sudoku-game.vala"
	g_return_if_fail (from != NULL);
#line 185 "../lib/sudoku-game.vala"
	g_return_if_fail (to != NULL);
#line 187 "../lib/sudoku-game.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) from);
#line 187 "../lib/sudoku-game.vala"
	_tmp1_ = _tmp0_;
#line 187 "../lib/sudoku-game.vala"
	if (_tmp1_ == 0) {
#line 188 "../lib/sudoku-game.vala"
		return;
#line 1017 "sudoku-game.c"
	}
#line 190 "../lib/sudoku-game.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) from);
#line 190 "../lib/sudoku-game.vala"
	_tmp3_ = _tmp2_;
#line 190 "../lib/sudoku-game.vala"
	_tmp4_ = gee_list_remove_at (from, _tmp3_ - 1);
#line 190 "../lib/sudoku-game.vala"
	top = (SudokuGameUndoItem*) _tmp4_;
#line 191 "../lib/sudoku-game.vala"
	_tmp5_ = self->board;
#line 191 "../lib/sudoku-game.vala"
	_tmp6_ = top;
#line 191 "../lib/sudoku-game.vala"
	_tmp7_ = top;
#line 191 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp5_, (*_tmp6_).row, (*_tmp7_).col);
#line 192 "../lib/sudoku-game.vala"
	_tmp8_ = self->board;
#line 192 "../lib/sudoku-game.vala"
	_tmp9_ = top;
#line 192 "../lib/sudoku-game.vala"
	_tmp10_ = top;
#line 192 "../lib/sudoku-game.vala"
	_tmp12_ = sudoku_board_get_earmarks (_tmp8_, (*_tmp9_).row, (*_tmp10_).col, &_tmp11_);
#line 192 "../lib/sudoku-game.vala"
	old_earmarks = _tmp12_;
#line 192 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp11_;
#line 192 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 193 "../lib/sudoku-game.vala"
	_tmp13_ = top;
#line 193 "../lib/sudoku-game.vala"
	_tmp14_ = top;
#line 193 "../lib/sudoku-game.vala"
	_tmp15_ = old_earmarks;
#line 193 "../lib/sudoku-game.vala"
	_tmp15__length1 = old_earmarks_length1;
#line 193 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, to, (*_tmp13_).row, (*_tmp14_).col, old_val, _tmp15_, (gint) _tmp15__length1);
#line 195 "../lib/sudoku-game.vala"
	_tmp16_ = self->mode;
#line 195 "../lib/sudoku-game.vala"
	if (_tmp16_ == GAME_MODE_CREATE) {
#line 1063 "sudoku-game.c"
		SudokuBoard* _tmp17_;
		SudokuGameUndoItem* _tmp18_;
		SudokuGameUndoItem* _tmp19_;
		SudokuBoard* _tmp20_;
		gboolean* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		SudokuGameUndoItem* _tmp22_;
		SudokuGameUndoItem* _tmp23_;
		gboolean _tmp24_;
		SudokuBoard* _tmp25_;
		gboolean* _tmp26_;
		gint _tmp26__length1;
		gint _tmp26__length2;
		SudokuGameUndoItem* _tmp27_;
		SudokuGameUndoItem* _tmp28_;
#line 197 "../lib/sudoku-game.vala"
		_tmp17_ = self->board;
#line 197 "../lib/sudoku-game.vala"
		_tmp18_ = top;
#line 197 "../lib/sudoku-game.vala"
		_tmp19_ = top;
#line 197 "../lib/sudoku-game.vala"
		_tmp20_ = self->board;
#line 197 "../lib/sudoku-game.vala"
		_tmp21_ = _tmp20_->is_fixed;
#line 197 "../lib/sudoku-game.vala"
		_tmp21__length1 = _tmp20_->is_fixed_length1;
#line 197 "../lib/sudoku-game.vala"
		_tmp21__length2 = _tmp20_->is_fixed_length2;
#line 197 "../lib/sudoku-game.vala"
		_tmp22_ = top;
#line 197 "../lib/sudoku-game.vala"
		_tmp23_ = top;
#line 197 "../lib/sudoku-game.vala"
		_tmp24_ = _tmp21_[((*_tmp22_).row * _tmp21__length2) + (*_tmp23_).col];
#line 197 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp17_, (*_tmp18_).row, (*_tmp19_).col, _tmp24_);
#line 198 "../lib/sudoku-game.vala"
		_tmp25_ = self->board;
#line 198 "../lib/sudoku-game.vala"
		_tmp26_ = _tmp25_->is_fixed;
#line 198 "../lib/sudoku-game.vala"
		_tmp26__length1 = _tmp25_->is_fixed_length1;
#line 198 "../lib/sudoku-game.vala"
		_tmp26__length2 = _tmp25_->is_fixed_length2;
#line 198 "../lib/sudoku-game.vala"
		_tmp27_ = top;
#line 198 "../lib/sudoku-game.vala"
		_tmp28_ = top;
#line 198 "../lib/sudoku-game.vala"
		_tmp26_[((*_tmp27_).row * _tmp26__length2) + (*_tmp28_).col] = FALSE;
#line 1116 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp29_;
		SudokuGameUndoItem* _tmp30_;
		SudokuGameUndoItem* _tmp31_;
#line 201 "../lib/sudoku-game.vala"
		_tmp29_ = self->board;
#line 201 "../lib/sudoku-game.vala"
		_tmp30_ = top;
#line 201 "../lib/sudoku-game.vala"
		_tmp31_ = top;
#line 201 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp29_, (*_tmp30_).row, (*_tmp31_).col, FALSE);
#line 1129 "sudoku-game.c"
	}
#line 203 "../lib/sudoku-game.vala"
	_tmp32_ = top;
#line 203 "../lib/sudoku-game.vala"
	if ((*_tmp32_).val != 0) {
#line 1135 "sudoku-game.c"
		GameMode _tmp33_;
#line 205 "../lib/sudoku-game.vala"
		_tmp33_ = self->mode;
#line 205 "../lib/sudoku-game.vala"
		if (_tmp33_ == GAME_MODE_CREATE) {
#line 1141 "sudoku-game.c"
			SudokuBoard* _tmp34_;
			SudokuGameUndoItem* _tmp35_;
			SudokuGameUndoItem* _tmp36_;
			SudokuGameUndoItem* _tmp37_;
			SudokuBoard* _tmp38_;
			gboolean* _tmp39_;
			gint _tmp39__length1;
			gint _tmp39__length2;
			SudokuGameUndoItem* _tmp40_;
			SudokuGameUndoItem* _tmp41_;
			gboolean _tmp42_;
			SudokuBoard* _tmp43_;
			gboolean* _tmp44_;
			gint _tmp44__length1;
			gint _tmp44__length2;
			SudokuGameUndoItem* _tmp45_;
			SudokuGameUndoItem* _tmp46_;
#line 207 "../lib/sudoku-game.vala"
			_tmp34_ = self->board;
#line 207 "../lib/sudoku-game.vala"
			_tmp35_ = top;
#line 207 "../lib/sudoku-game.vala"
			_tmp36_ = top;
#line 207 "../lib/sudoku-game.vala"
			_tmp37_ = top;
#line 207 "../lib/sudoku-game.vala"
			_tmp38_ = self->board;
#line 207 "../lib/sudoku-game.vala"
			_tmp39_ = _tmp38_->is_fixed;
#line 207 "../lib/sudoku-game.vala"
			_tmp39__length1 = _tmp38_->is_fixed_length1;
#line 207 "../lib/sudoku-game.vala"
			_tmp39__length2 = _tmp38_->is_fixed_length2;
#line 207 "../lib/sudoku-game.vala"
			_tmp40_ = top;
#line 207 "../lib/sudoku-game.vala"
			_tmp41_ = top;
#line 207 "../lib/sudoku-game.vala"
			_tmp42_ = _tmp39_[((*_tmp40_).row * _tmp39__length2) + (*_tmp41_).col];
#line 207 "../lib/sudoku-game.vala"
			sudoku_board_insert (_tmp34_, (*_tmp35_).row, (*_tmp36_).col, (*_tmp37_).val, _tmp42_);
#line 208 "../lib/sudoku-game.vala"
			_tmp43_ = self->board;
#line 208 "../lib/sudoku-game.vala"
			_tmp44_ = _tmp43_->is_fixed;
#line 208 "../lib/sudoku-game.vala"
			_tmp44__length1 = _tmp43_->is_fixed_length1;
#line 208 "../lib/sudoku-game.vala"
			_tmp44__length2 = _tmp43_->is_fixed_length2;
#line 208 "../lib/sudoku-game.vala"
			_tmp45_ = top;
#line 208 "../lib/sudoku-game.vala"
			_tmp46_ = top;
#line 208 "../lib/sudoku-game.vala"
			_tmp44_[((*_tmp45_).row * _tmp44__length2) + (*_tmp46_).col] = TRUE;
#line 1197 "sudoku-game.c"
		} else {
			SudokuBoard* _tmp47_;
			SudokuGameUndoItem* _tmp48_;
			SudokuGameUndoItem* _tmp49_;
			SudokuGameUndoItem* _tmp50_;
#line 211 "../lib/sudoku-game.vala"
			_tmp47_ = self->board;
#line 211 "../lib/sudoku-game.vala"
			_tmp48_ = top;
#line 211 "../lib/sudoku-game.vala"
			_tmp49_ = top;
#line 211 "../lib/sudoku-game.vala"
			_tmp50_ = top;
#line 211 "../lib/sudoku-game.vala"
			sudoku_board_insert (_tmp47_, (*_tmp48_).row, (*_tmp49_).col, (*_tmp50_).val, FALSE);
#line 1213 "sudoku-game.c"
		}
	}
	{
		gint i = 0;
#line 214 "../lib/sudoku-game.vala"
		i = 1;
#line 1220 "sudoku-game.c"
		{
			gboolean _tmp51_ = FALSE;
#line 214 "../lib/sudoku-game.vala"
			_tmp51_ = TRUE;
#line 214 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1227 "sudoku-game.c"
				SudokuGameUndoItem* _tmp53_;
				gboolean* _tmp54_;
				gint _tmp54__length1;
				SudokuGameUndoItem* _tmp55_;
				gboolean* _tmp56_;
				gint _tmp56__length1;
				gboolean _tmp57_;
#line 214 "../lib/sudoku-game.vala"
				if (!_tmp51_) {
#line 1237 "sudoku-game.c"
					gint _tmp52_;
#line 214 "../lib/sudoku-game.vala"
					_tmp52_ = i;
#line 214 "../lib/sudoku-game.vala"
					i = _tmp52_ + 1;
#line 1243 "sudoku-game.c"
				}
#line 214 "../lib/sudoku-game.vala"
				_tmp51_ = FALSE;
#line 214 "../lib/sudoku-game.vala"
				_tmp53_ = top;
#line 214 "../lib/sudoku-game.vala"
				_tmp54_ = (*_tmp53_).earmarks;
#line 214 "../lib/sudoku-game.vala"
				_tmp54__length1 = (*_tmp53_).earmarks_length1;
#line 214 "../lib/sudoku-game.vala"
				if (!(i <= _tmp54__length1)) {
#line 214 "../lib/sudoku-game.vala"
					break;
#line 1257 "sudoku-game.c"
				}
#line 216 "../lib/sudoku-game.vala"
				_tmp55_ = top;
#line 216 "../lib/sudoku-game.vala"
				_tmp56_ = (*_tmp55_).earmarks;
#line 216 "../lib/sudoku-game.vala"
				_tmp56__length1 = (*_tmp55_).earmarks_length1;
#line 216 "../lib/sudoku-game.vala"
				_tmp57_ = _tmp56_[i - 1];
#line 216 "../lib/sudoku-game.vala"
				if (_tmp57_) {
#line 1269 "sudoku-game.c"
					SudokuBoard* _tmp58_;
					SudokuGameUndoItem* _tmp59_;
					SudokuGameUndoItem* _tmp60_;
#line 217 "../lib/sudoku-game.vala"
					_tmp58_ = self->board;
#line 217 "../lib/sudoku-game.vala"
					_tmp59_ = top;
#line 217 "../lib/sudoku-game.vala"
					_tmp60_ = top;
#line 217 "../lib/sudoku-game.vala"
					sudoku_board_enable_earmark (_tmp58_, (*_tmp59_).row, (*_tmp60_).col, i);
#line 1281 "sudoku-game.c"
				} else {
					SudokuBoard* _tmp61_;
					SudokuGameUndoItem* _tmp62_;
					SudokuGameUndoItem* _tmp63_;
#line 219 "../lib/sudoku-game.vala"
					_tmp61_ = self->board;
#line 219 "../lib/sudoku-game.vala"
					_tmp62_ = top;
#line 219 "../lib/sudoku-game.vala"
					_tmp63_ = top;
#line 219 "../lib/sudoku-game.vala"
					sudoku_board_disable_earmark (_tmp61_, (*_tmp62_).row, (*_tmp63_).col, i);
#line 1294 "sudoku-game.c"
				}
			}
		}
	}
#line 222 "../lib/sudoku-game.vala"
	_tmp64_ = top;
#line 222 "../lib/sudoku-game.vala"
	_tmp65_ = top;
#line 222 "../lib/sudoku-game.vala"
	_tmp66_ = top;
#line 222 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, (*_tmp64_).row, (*_tmp65_).col, old_val, (*_tmp66_).val);
#line 185 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 185 "../lib/sudoku-game.vala"
	_sudoku_game_undo_item_free0 (top);
#line 1311 "sudoku-game.c"
}

gdouble
sudoku_game_get_total_time_played (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimer* _tmp3_;
	gdouble result = 0.0;
#line 225 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 227 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 227 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
#line 227 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 227 "../lib/sudoku-game.vala"
	_tmp3_ = self->timer;
#line 227 "../lib/sudoku-game.vala"
	result = _tmp2_ + g_timer_elapsed (_tmp3_, NULL);
#line 227 "../lib/sudoku-game.vala"
	return result;
#line 1336 "sudoku-game.c"
}

static gboolean
_sudoku_game_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = sudoku_game_timeout_cb ((SudokuGame*) self);
#line 232 "../lib/sudoku-game.vala"
	return result;
#line 1346 "sudoku-game.c"
}

static gboolean
sudoku_game_timeout_cb (SudokuGame* self)
{
	gboolean result = FALSE;
#line 230 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sudoku_game_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 233 "../lib/sudoku-game.vala"
	g_source_set_name_by_id (self->priv->clock_timeout, "[gnome-sudoku] timeout_cb");
#line 234 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 235 "../lib/sudoku-game.vala"
	result = FALSE;
#line 235 "../lib/sudoku-game.vala"
	return result;
#line 1365 "sudoku-game.c"
}

void
sudoku_game_start_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp2_;
#line 238 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 240 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 240 "../lib/sudoku-game.vala"
	if (_tmp0_ == NULL) {
#line 1379 "sudoku-game.c"
		GTimer* _tmp1_;
#line 241 "../lib/sudoku-game.vala"
		_tmp1_ = g_timer_new ();
#line 241 "../lib/sudoku-game.vala"
		_g_timer_destroy0 (self->timer);
#line 241 "../lib/sudoku-game.vala"
		self->timer = _tmp1_;
#line 1387 "sudoku-game.c"
	}
#line 242 "../lib/sudoku-game.vala"
	_tmp2_ = self->timer;
#line 242 "../lib/sudoku-game.vala"
	g_timer_start (_tmp2_);
#line 243 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1395 "sudoku-game.c"
}

void
sudoku_game_stop_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 246 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 246 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 246 "../lib/sudoku-game.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "timer != null");
#line 249 "../lib/sudoku-game.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 250 "../lib/sudoku-game.vala"
		g_source_remove (self->priv->clock_timeout);
#line 1413 "sudoku-game.c"
	}
#line 251 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = (guint) 0;
#line 252 "../lib/sudoku-game.vala"
	sudoku_game_set_paused (self, TRUE);
#line 253 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 253 "../lib/sudoku-game.vala"
	g_timer_stop (_tmp1_);
#line 254 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 1425 "sudoku-game.c"
}

void
sudoku_game_resume_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 257 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 257 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 257 "../lib/sudoku-game.vala"
	_vala_return_if_fail ((_tmp0_ != NULL) && (self->priv->clock_timeout == ((guint) 0)), "timer != null && clock_timeout == 0");
#line 260 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 260 "../lib/sudoku-game.vala"
	g_timer_continue (_tmp1_);
#line 261 "../lib/sudoku-game.vala"
	sudoku_game_set_paused (self, FALSE);
#line 262 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1447 "sudoku-game.c"
}

gboolean
sudoku_game_get_paused (SudokuGame* self)
{
	gboolean result;
#line 42 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../lib/sudoku-game.vala"
	result = self->priv->_paused;
#line 42 "../lib/sudoku-game.vala"
	return result;
#line 1460 "sudoku-game.c"
}

static void
sudoku_game_set_paused (SudokuGame* self,
                        gboolean value)
{
#line 37 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/sudoku-game.vala"
	self->priv->_paused = value;
#line 40 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL], 0);
#line 37 "../lib/sudoku-game.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY]);
#line 1475 "sudoku-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../lib/sudoku-game.vala"
	g_return_if_fail (n_param_values == 5);
#line 24 "../lib/sudoku-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../lib/sudoku-game.vala"
		data1 = closure->data;
#line 24 "../lib/sudoku-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 1500 "sudoku-game.c"
	} else {
#line 24 "../lib/sudoku-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../lib/sudoku-game.vala"
		data2 = closure->data;
#line 1506 "sudoku-game.c"
	}
#line 24 "../lib/sudoku-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../lib/sudoku-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 1512 "sudoku-game.c"
}

static gboolean*
_vala_array_dup10 (gboolean* self,
                   int length)
{
#line 45 "../lib/sudoku-game.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1521 "sudoku-game.c"
}

static void
sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                            SudokuGameUndoItem* dest)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gboolean* _tmp1_;
	gint _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).row = (*self).row;
#line 45 "../lib/sudoku-game.vala"
	(*dest).col = (*self).col;
#line 45 "../lib/sudoku-game.vala"
	(*dest).val = (*self).val;
#line 45 "../lib/sudoku-game.vala"
	_tmp0_ = (*self).earmarks;
#line 45 "../lib/sudoku-game.vala"
	_tmp0__length1 = (*self).earmarks_length1;
#line 45 "../lib/sudoku-game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup10 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 45 "../lib/sudoku-game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = (g_free ((*dest).earmarks), NULL);
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = _tmp1_;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks_length1 = _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest)._earmarks_size_ = (*dest).earmarks_length1;
#line 1554 "sudoku-game.c"
}

static void
sudoku_game_undo_item_destroy (SudokuGameUndoItem* self)
{
#line 50 "../lib/sudoku-game.vala"
	(*self).earmarks = (g_free ((*self).earmarks), NULL);
#line 1562 "sudoku-game.c"
}

static SudokuGameUndoItem*
sudoku_game_undo_item_dup (const SudokuGameUndoItem* self)
{
	SudokuGameUndoItem* dup;
#line 45 "../lib/sudoku-game.vala"
	dup = g_new0 (SudokuGameUndoItem, 1);
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_copy (self, dup);
#line 45 "../lib/sudoku-game.vala"
	return dup;
#line 1575 "sudoku-game.c"
}

static void
sudoku_game_undo_item_free (SudokuGameUndoItem* self)
{
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (self);
#line 45 "../lib/sudoku-game.vala"
	g_free (self);
#line 1585 "sudoku-game.c"
}

static GType
sudoku_game_undo_item_get_type (void)
{
	static volatile gsize sudoku_game_undo_item_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_undo_item_type_id__volatile)) {
		GType sudoku_game_undo_item_type_id;
		sudoku_game_undo_item_type_id = g_boxed_type_register_static ("SudokuGameUndoItem", (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GBoxedFreeFunc) sudoku_game_undo_item_free);
		g_once_init_leave (&sudoku_game_undo_item_type_id__volatile, sudoku_game_undo_item_type_id);
	}
	return sudoku_game_undo_item_type_id__volatile;
}

static void
sudoku_game_class_init (SudokuGameClass * klass,
                        gpointer klass_data)
{
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-game.vala"
	g_type_class_adjust_private_offset (klass, &SudokuGame_private_offset);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_game_get_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_game_set_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_PAUSED_PROPERTY, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL] = g_signal_new ("tick", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL] = g_signal_new ("cell-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 1622 "sudoku-game.c"
}

static void
sudoku_game_instance_init (SudokuGame * self,
                           gpointer klass)
{
#line 24 "../lib/sudoku-game.vala"
	self->priv = sudoku_game_get_instance_private (self);
#line 34 "../lib/sudoku-game.vala"
	self->priv->_paused = FALSE;
#line 1633 "sudoku-game.c"
}

static void
sudoku_game_finalize (GObject * obj)
{
	SudokuGame * self;
#line 24 "../lib/sudoku-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
#line 26 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->board);
#line 28 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->timer);
#line 55 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 56 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
#line 1652 "sudoku-game.c"
}

GType
sudoku_game_get_type (void)
{
	static volatile gsize sudoku_game_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
		GType sudoku_game_type_id;
		sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
		SudokuGame_private_offset = g_type_add_instance_private (sudoku_game_type_id, sizeof (SudokuGamePrivate));
		g_once_init_leave (&sudoku_game_type_id__volatile, sudoku_game_type_id);
	}
	return sudoku_game_type_id__volatile;
}

static void
_vala_sudoku_game_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_boolean (value, sudoku_game_get_paused (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1685 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1691 "sudoku-game.c"
	}
}

static void
_vala_sudoku_game_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_paused (self, g_value_get_boolean (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1711 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1717 "sudoku-game.c"
	}
}

GType
game_mode_get_type (void)
{
	static volatile gsize game_mode_type_id__volatile = 0;
	if (g_once_init_enter (&game_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_MODE_PLAY, "GAME_MODE_PLAY", "play"}, {GAME_MODE_CREATE, "GAME_MODE_CREATE", "create"}, {0, NULL, NULL}};
		GType game_mode_type_id;
		game_mode_type_id = g_enum_register_static ("GameMode", values);
		g_once_init_leave (&game_mode_type_id__volatile, game_mode_type_id);
	}
	return game_mode_type_id__volatile;
}

