/* sudoku-saver.c generated by valac 0.46.0, the Vala compiler
 * generated from sudoku-saver.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>

#define TYPE_SUDOKU_SAVER (sudoku_saver_get_type ())
#define SUDOKU_SAVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_SAVER, SudokuSaver))
#define SUDOKU_SAVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_SAVER, SudokuSaverClass))
#define IS_SUDOKU_SAVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_SAVER))
#define IS_SUDOKU_SAVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_SAVER))
#define SUDOKU_SAVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_SAVER, SudokuSaverClass))

typedef struct _SudokuSaver SudokuSaver;
typedef struct _SudokuSaverClass SudokuSaverClass;
typedef struct _SudokuSaverPrivate SudokuSaverPrivate;
enum  {
	SUDOKU_SAVER_0_PROPERTY,
	SUDOKU_SAVER_NUM_PROPERTIES
};
static GParamSpec* sudoku_saver_properties[SUDOKU_SAVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_SUDOKU_GAME (sudoku_game_get_type ())
#define SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_GAME, SudokuGame))
#define SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_GAME, SudokuGameClass))
#define IS_SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_GAME))
#define IS_SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_GAME))
#define SUDOKU_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_GAME, SudokuGameClass))

typedef struct _SudokuGame SudokuGame;
typedef struct _SudokuGameClass SudokuGameClass;
typedef struct _SudokuGamePrivate SudokuGamePrivate;

#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;
typedef enum  {
	GAME_MODE_PLAY,
	GAME_MODE_CREATE
} GameMode;

#define TYPE_GAME_MODE (game_mode_get_type ())
typedef enum  {
	DIFFICULTY_CATEGORY_UNKNOWN,
	DIFFICULTY_CATEGORY_EASY,
	DIFFICULTY_CATEGORY_MEDIUM,
	DIFFICULTY_CATEGORY_HARD,
	DIFFICULTY_CATEGORY_VERY_HARD,
	DIFFICULTY_CATEGORY_CUSTOM
} DifficultyCategory;

#define TYPE_DIFFICULTY_CATEGORY (difficulty_category_get_type ())
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

struct _SudokuSaver {
	GObject parent_instance;
	SudokuSaverPrivate * priv;
};

struct _SudokuSaverClass {
	GObjectClass parent_class;
};

struct _SudokuGame {
	GObject parent_instance;
	SudokuGamePrivate * priv;
	SudokuBoard* board;
	GameMode mode;
	GTimer* timer;
};

struct _SudokuGameClass {
	GObjectClass parent_class;
};

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};

static gpointer sudoku_saver_parent_class = NULL;
static gchar* sudoku_saver__savegame_file;
static gchar* sudoku_saver__savegame_file = NULL;
static gchar* sudoku_saver__finishgame_dir;
static gchar* sudoku_saver__finishgame_dir = NULL;

GType sudoku_saver_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuSaver, g_object_unref)
SudokuSaver* sudoku_saver_new (void);
SudokuSaver* sudoku_saver_construct (GType object_type);
static void sudoku_saver_set_savegame_file (const gchar* value);
static void sudoku_saver_set_finishgame_dir (const gchar* value);
const gchar* sudoku_saver_get_finishgame_dir (void);
GType sudoku_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuGame, g_object_unref)
SudokuGame* sudoku_saver_get_savedgame (SudokuSaver* self);
const gchar* sudoku_saver_get_savegame_file (void);
static SudokuGame* sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                             const gchar* file_path);
void sudoku_saver_save_game (SudokuSaver* self,
                             SudokuGame* game);
static void sudoku_saver_create_file_for_game (SudokuSaver* self,
                                        SudokuGame* game,
                                        const gchar* file_name);
void sudoku_saver_add_game_to_finished (SudokuSaver* self,
                                        SudokuGame* game,
                                        gboolean delete_savegame);
GType sudoku_board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuBoard, g_object_unref)
GType game_mode_get_type (void) G_GNUC_CONST;
gchar* sudoku_board_to_string (SudokuBoard* self,
                               gboolean get_original_state);
static gchar* sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                            SudokuGame* game);
gint* sudoku_board_get_cells (SudokuBoard* self,
                              gint* result_length1,
                              gint* result_length2);
GType difficulty_category_get_type (void) G_GNUC_CONST;
DifficultyCategory sudoku_board_get_difficulty_category (SudokuBoard* self);
gchar* difficulty_category_to_untranslated_string (DifficultyCategory self);
gdouble sudoku_game_get_total_time_played (SudokuGame* self);
gint sudoku_board_get_rows (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
gint sudoku_board_get_max_val (SudokuBoard* self);
gboolean sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                          gint row,
                                          gint column,
                                          gint digit);
static void _vala_array_add1 (gint* * array,
                       int* length,
                       int* size,
                       gint value);
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
static void _vala_JsonNode_free (JsonNode* self);
SudokuBoard* sudoku_board_new (gint block_rows,
                               gint block_cols);
SudokuBoard* sudoku_board_construct (GType object_type,
                                     gint block_rows,
                                     gint block_cols);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
void sudoku_board_insert (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val,
                          gboolean is_fixed);
void sudoku_board_enable_earmark (SudokuBoard* self,
                                  gint row,
                                  gint column,
                                  gint digit);
void sudoku_board_set_previous_played_time (SudokuBoard* self,
                                            gdouble value);
DifficultyCategory difficulty_category_from_string (const gchar* input);
void sudoku_board_set_difficulty_category (SudokuBoard* self,
                                           DifficultyCategory value);
SudokuGame* sudoku_game_new (SudokuBoard* board);
SudokuGame* sudoku_game_construct (GType object_type,
                                   SudokuBoard* board);
static void sudoku_saver_finalize (GObject * obj);
static void _vala_sudoku_saver_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_saver_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

SudokuSaver*
sudoku_saver_construct (GType object_type)
{
	SudokuSaver * self = NULL;
	GError* _inner_error0_ = NULL;
#line 29 "../lib/sudoku-saver.vala"
	self = (SudokuSaver*) g_object_new (object_type, NULL);
#line 239 "sudoku-saver.c"
	{
		gchar* config_dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* sudoku_data_dir = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* file = NULL;
		const gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 34 "../lib/sudoku-saver.vala"
		_tmp0_ = g_get_user_data_dir ();
#line 34 "../lib/sudoku-saver.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 34 "../lib/sudoku-saver.vala"
		config_dir = _tmp1_;
#line 35 "../lib/sudoku-saver.vala"
		_tmp2_ = config_dir;
#line 35 "../lib/sudoku-saver.vala"
		_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "gnome-sudoku", NULL);
#line 35 "../lib/sudoku-saver.vala"
		sudoku_data_dir = _tmp3_;
#line 36 "../lib/sudoku-saver.vala"
		_tmp4_ = sudoku_data_dir;
#line 36 "../lib/sudoku-saver.vala"
		_tmp5_ = g_build_path (G_DIR_SEPARATOR_S, _tmp4_, "savefile", NULL);
#line 36 "../lib/sudoku-saver.vala"
		_tmp6_ = _tmp5_;
#line 36 "../lib/sudoku-saver.vala"
		sudoku_saver_set_savegame_file (_tmp6_);
#line 36 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp6_);
#line 37 "../lib/sudoku-saver.vala"
		_tmp7_ = sudoku_data_dir;
#line 37 "../lib/sudoku-saver.vala"
		_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp7_, "finished", NULL);
#line 37 "../lib/sudoku-saver.vala"
		_tmp9_ = _tmp8_;
#line 37 "../lib/sudoku-saver.vala"
		sudoku_saver_set_finishgame_dir (_tmp9_);
#line 37 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp9_);
#line 38 "../lib/sudoku-saver.vala"
		_tmp10_ = sudoku_data_dir;
#line 38 "../lib/sudoku-saver.vala"
		_tmp11_ = g_file_new_for_path (_tmp10_);
#line 38 "../lib/sudoku-saver.vala"
		file = _tmp11_;
#line 39 "../lib/sudoku-saver.vala"
		_tmp12_ = file;
#line 39 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp12_, NULL)) {
#line 303 "sudoku-saver.c"
			GFile* _tmp13_;
#line 40 "../lib/sudoku-saver.vala"
			_tmp13_ = file;
#line 40 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp13_, NULL, &_inner_error0_);
#line 40 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 40 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 40 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 317 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 42 "../lib/sudoku-saver.vala"
		_tmp14_ = sudoku_saver_get_finishgame_dir ();
#line 42 "../lib/sudoku-saver.vala"
		_tmp15_ = _tmp14_;
#line 42 "../lib/sudoku-saver.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 42 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 42 "../lib/sudoku-saver.vala"
		file = _tmp16_;
#line 43 "../lib/sudoku-saver.vala"
		_tmp17_ = file;
#line 43 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp17_, NULL)) {
#line 335 "sudoku-saver.c"
			GFile* _tmp18_;
#line 44 "../lib/sudoku-saver.vala"
			_tmp18_ = file;
#line 44 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp18_, NULL, &_inner_error0_);
#line 44 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 44 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 44 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 349 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 31 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (sudoku_data_dir);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (config_dir);
#line 359 "sudoku-saver.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 31 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 31 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 48 "../lib/sudoku-saver.vala"
		_tmp19_ = e;
#line 48 "../lib/sudoku-saver.vala"
		_tmp20_ = _tmp19_->message;
#line 48 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:48: %s", _tmp20_);
#line 31 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 379 "sudoku-saver.c"
	}
	__finally0:
#line 31 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../lib/sudoku-saver.vala"
		return NULL;
#line 390 "sudoku-saver.c"
	}
#line 29 "../lib/sudoku-saver.vala"
	return self;
#line 394 "sudoku-saver.c"
}

SudokuSaver*
sudoku_saver_new (void)
{
#line 29 "../lib/sudoku-saver.vala"
	return sudoku_saver_construct (TYPE_SUDOKU_SAVER);
#line 402 "sudoku-saver.c"
}

SudokuGame*
sudoku_saver_get_savedgame (SudokuSaver* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	SudokuGame* _tmp6_;
	SudokuGame* result = NULL;
#line 52 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 54 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 54 "../lib/sudoku-saver.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 54 "../lib/sudoku-saver.vala"
	file = _tmp2_;
#line 55 "../lib/sudoku-saver.vala"
	_tmp3_ = file;
#line 55 "../lib/sudoku-saver.vala"
	if (!g_file_query_exists (_tmp3_, NULL)) {
#line 56 "../lib/sudoku-saver.vala"
		result = NULL;
#line 56 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 56 "../lib/sudoku-saver.vala"
		return result;
#line 437 "sudoku-saver.c"
	}
#line 58 "../lib/sudoku-saver.vala"
	_tmp4_ = sudoku_saver_get_savegame_file ();
#line 58 "../lib/sudoku-saver.vala"
	_tmp5_ = _tmp4_;
#line 58 "../lib/sudoku-saver.vala"
	_tmp6_ = sudoku_saver_parse_json_to_game (self, _tmp5_);
#line 58 "../lib/sudoku-saver.vala"
	result = _tmp6_;
#line 58 "../lib/sudoku-saver.vala"
	_g_object_unref0 (file);
#line 58 "../lib/sudoku-saver.vala"
	return result;
#line 451 "sudoku-saver.c"
}

void
sudoku_saver_save_game (SudokuSaver* self,
                        SudokuGame* game)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 61 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 63 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 63 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 63 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp1_);
#line 470 "sudoku-saver.c"
}

void
sudoku_saver_add_game_to_finished (SudokuSaver* self,
                                   SudokuGame* game,
                                   gboolean delete_savegame)
{
	gchar* file_name = NULL;
	SudokuBoard* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* file_path = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 66 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 68 "../lib/sudoku-saver.vala"
	_tmp0_ = game->board;
#line 68 "../lib/sudoku-saver.vala"
	_tmp1_ = sudoku_board_to_string (_tmp0_, TRUE);
#line 68 "../lib/sudoku-saver.vala"
	_tmp2_ = _tmp1_;
#line 68 "../lib/sudoku-saver.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".save", NULL);
#line 68 "../lib/sudoku-saver.vala"
	_tmp4_ = _tmp3_;
#line 68 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp2_);
#line 68 "../lib/sudoku-saver.vala"
	file_name = _tmp4_;
#line 69 "../lib/sudoku-saver.vala"
	_tmp5_ = sudoku_saver_get_finishgame_dir ();
#line 69 "../lib/sudoku-saver.vala"
	_tmp6_ = _tmp5_;
#line 69 "../lib/sudoku-saver.vala"
	_tmp7_ = file_name;
#line 69 "../lib/sudoku-saver.vala"
	_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp6_, _tmp7_, NULL);
#line 69 "../lib/sudoku-saver.vala"
	file_path = _tmp8_;
#line 70 "../lib/sudoku-saver.vala"
	_tmp9_ = file_path;
#line 70 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp9_);
#line 72 "../lib/sudoku-saver.vala"
	if (delete_savegame) {
#line 525 "sudoku-saver.c"
		GFile* file = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
#line 75 "../lib/sudoku-saver.vala"
		_tmp10_ = sudoku_saver_get_savegame_file ();
#line 75 "../lib/sudoku-saver.vala"
		_tmp11_ = _tmp10_;
#line 75 "../lib/sudoku-saver.vala"
		_tmp12_ = g_file_new_for_path (_tmp11_);
#line 75 "../lib/sudoku-saver.vala"
		file = _tmp12_;
#line 76 "../lib/sudoku-saver.vala"
		_tmp13_ = file;
#line 76 "../lib/sudoku-saver.vala"
		if (g_file_query_exists (_tmp13_, NULL)) {
#line 543 "sudoku-saver.c"
			{
				GFile* _tmp14_;
#line 80 "../lib/sudoku-saver.vala"
				_tmp14_ = file;
#line 80 "../lib/sudoku-saver.vala"
				g_file_delete (_tmp14_, NULL, &_inner_error0_);
#line 80 "../lib/sudoku-saver.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 552 "sudoku-saver.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GFile* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				GError* _tmp18_;
				const gchar* _tmp19_;
#line 78 "../lib/sudoku-saver.vala"
				e = _inner_error0_;
#line 78 "../lib/sudoku-saver.vala"
				_inner_error0_ = NULL;
#line 84 "../lib/sudoku-saver.vala"
				_tmp15_ = file;
#line 84 "../lib/sudoku-saver.vala"
				_tmp16_ = g_file_get_uri (_tmp15_);
#line 84 "../lib/sudoku-saver.vala"
				_tmp17_ = _tmp16_;
#line 84 "../lib/sudoku-saver.vala"
				_tmp18_ = e;
#line 84 "../lib/sudoku-saver.vala"
				_tmp19_ = _tmp18_->message;
#line 84 "../lib/sudoku-saver.vala"
				g_warning ("sudoku-saver.vala:84: Failed to delete %s: %s", _tmp17_, _tmp19_);
#line 84 "../lib/sudoku-saver.vala"
				_g_free0 (_tmp17_);
#line 78 "../lib/sudoku-saver.vala"
				_g_error_free0 (e);
#line 585 "sudoku-saver.c"
			}
			__finally1:
#line 78 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 78 "../lib/sudoku-saver.vala"
				_g_free0 (file_path);
#line 78 "../lib/sudoku-saver.vala"
				_g_free0 (file_name);
#line 78 "../lib/sudoku-saver.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../lib/sudoku-saver.vala"
				g_clear_error (&_inner_error0_);
#line 78 "../lib/sudoku-saver.vala"
				return;
#line 602 "sudoku-saver.c"
			}
		}
#line 72 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 607 "sudoku-saver.c"
	}
#line 66 "../lib/sudoku-saver.vala"
	_g_free0 (file_path);
#line 66 "../lib/sudoku-saver.vala"
	_g_free0 (file_name);
#line 613 "sudoku-saver.c"
}

static void
sudoku_saver_create_file_for_game (SudokuSaver* self,
                                   SudokuGame* game,
                                   const gchar* file_name)
{
	gchar* json_str = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (file_name != NULL);
#line 92 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_serialize_game_to_json (self, game);
#line 92 "../lib/sudoku-saver.vala"
	json_str = _tmp0_;
#line 634 "sudoku-saver.c"
	{
#line 96 "../lib/sudoku-saver.vala"
		g_file_set_contents (file_name, json_str, (gssize) -1, &_inner_error0_);
#line 96 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 640 "sudoku-saver.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 94 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 94 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 100 "../lib/sudoku-saver.vala"
		_tmp1_ = e;
#line 100 "../lib/sudoku-saver.vala"
		_tmp2_ = _tmp1_->message;
#line 100 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:100: %s", _tmp2_);
#line 94 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 662 "sudoku-saver.c"
	}
	__finally2:
#line 94 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../lib/sudoku-saver.vala"
		_g_free0 (json_str);
#line 94 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../lib/sudoku-saver.vala"
		return;
#line 675 "sudoku-saver.c"
	}
#line 90 "../lib/sudoku-saver.vala"
	_g_free0 (json_str);
#line 679 "sudoku-saver.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../lib/sudoku-saver.vala"
	return self ? g_object_ref (self) : NULL;
#line 687 "sudoku-saver.c"
}

static void
_vala_array_add1 (gint* * array,
                  int* length,
                  int* size,
                  gint value)
{
#line 130 "../lib/sudoku-saver.vala"
	if ((*length) == (*size)) {
#line 130 "../lib/sudoku-saver.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 130 "../lib/sudoku-saver.vala"
		*array = g_renew (gint, *array, *size);
#line 702 "sudoku-saver.c"
	}
#line 130 "../lib/sudoku-saver.vala"
	(*array)[(*length)++] = value;
#line 706 "sudoku-saver.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 166 "../lib/sudoku-saver.vala"
	g_boxed_free (json_node_get_type (), self);
#line 714 "sudoku-saver.c"
}

static gchar*
sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                     SudokuGame* game)
{
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	gint* board_cells = NULL;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint board_cells_length1;
	gint board_cells_length2;
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	JsonBuilder* _tmp9_;
	SudokuBoard* _tmp10_;
	DifficultyCategory _tmp11_;
	DifficultyCategory _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonBuilder* _tmp15_;
	GameMode _tmp16_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp20_;
	JsonBuilder* _tmp64_;
	JsonBuilder* _tmp65_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp66_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp67_;
	JsonNode* _tmp68_;
	gchar* _tmp69_;
	gchar* result = NULL;
#line 104 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 106 "../lib/sudoku-saver.vala"
	_tmp0_ = game->board;
#line 106 "../lib/sudoku-saver.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 106 "../lib/sudoku-saver.vala"
	board = _tmp1_;
#line 107 "../lib/sudoku-saver.vala"
	_tmp2_ = board;
#line 107 "../lib/sudoku-saver.vala"
	_tmp5_ = sudoku_board_get_cells (_tmp2_, &_tmp3_, &_tmp4_);
#line 107 "../lib/sudoku-saver.vala"
	board_cells = _tmp5_;
#line 107 "../lib/sudoku-saver.vala"
	board_cells_length1 = _tmp3_;
#line 107 "../lib/sudoku-saver.vala"
	board_cells_length2 = _tmp4_;
#line 108 "../lib/sudoku-saver.vala"
	_tmp6_ = json_builder_new ();
#line 108 "../lib/sudoku-saver.vala"
	builder = _tmp6_;
#line 110 "../lib/sudoku-saver.vala"
	_tmp7_ = builder;
#line 110 "../lib/sudoku-saver.vala"
	json_builder_begin_object (_tmp7_);
#line 111 "../lib/sudoku-saver.vala"
	_tmp8_ = builder;
#line 111 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp8_, "difficulty_category");
#line 112 "../lib/sudoku-saver.vala"
	_tmp9_ = builder;
#line 112 "../lib/sudoku-saver.vala"
	_tmp10_ = board;
#line 112 "../lib/sudoku-saver.vala"
	_tmp11_ = sudoku_board_get_difficulty_category (_tmp10_);
#line 112 "../lib/sudoku-saver.vala"
	_tmp12_ = _tmp11_;
#line 112 "../lib/sudoku-saver.vala"
	_tmp13_ = difficulty_category_to_untranslated_string (_tmp12_);
#line 112 "../lib/sudoku-saver.vala"
	_tmp14_ = _tmp13_;
#line 112 "../lib/sudoku-saver.vala"
	json_builder_add_string_value (_tmp9_, _tmp14_);
#line 112 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp14_);
#line 114 "../lib/sudoku-saver.vala"
	_tmp15_ = builder;
#line 114 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp15_, "time_elapsed");
#line 115 "../lib/sudoku-saver.vala"
	_tmp16_ = game->mode;
#line 115 "../lib/sudoku-saver.vala"
	if (_tmp16_ == GAME_MODE_CREATE) {
#line 810 "sudoku-saver.c"
		JsonBuilder* _tmp17_;
#line 116 "../lib/sudoku-saver.vala"
		_tmp17_ = builder;
#line 116 "../lib/sudoku-saver.vala"
		json_builder_add_double_value (_tmp17_, (gdouble) 0);
#line 816 "sudoku-saver.c"
	} else {
		JsonBuilder* _tmp18_;
#line 118 "../lib/sudoku-saver.vala"
		_tmp18_ = builder;
#line 118 "../lib/sudoku-saver.vala"
		json_builder_add_double_value (_tmp18_, sudoku_game_get_total_time_played (game));
#line 823 "sudoku-saver.c"
	}
#line 120 "../lib/sudoku-saver.vala"
	_tmp19_ = builder;
#line 120 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp19_, "cells");
#line 121 "../lib/sudoku-saver.vala"
	_tmp20_ = builder;
#line 121 "../lib/sudoku-saver.vala"
	json_builder_begin_array (_tmp20_);
#line 833 "sudoku-saver.c"
	{
		gint i = 0;
#line 123 "../lib/sudoku-saver.vala"
		i = 0;
#line 838 "sudoku-saver.c"
		{
			gboolean _tmp21_ = FALSE;
#line 123 "../lib/sudoku-saver.vala"
			_tmp21_ = TRUE;
#line 123 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 845 "sudoku-saver.c"
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 123 "../lib/sudoku-saver.vala"
				if (!_tmp21_) {
#line 851 "sudoku-saver.c"
					gint _tmp22_;
#line 123 "../lib/sudoku-saver.vala"
					_tmp22_ = i;
#line 123 "../lib/sudoku-saver.vala"
					i = _tmp22_ + 1;
#line 857 "sudoku-saver.c"
				}
#line 123 "../lib/sudoku-saver.vala"
				_tmp21_ = FALSE;
#line 123 "../lib/sudoku-saver.vala"
				_tmp23_ = board;
#line 123 "../lib/sudoku-saver.vala"
				_tmp24_ = sudoku_board_get_rows (_tmp23_);
#line 123 "../lib/sudoku-saver.vala"
				_tmp25_ = _tmp24_;
#line 123 "../lib/sudoku-saver.vala"
				if (!(i < _tmp25_)) {
#line 123 "../lib/sudoku-saver.vala"
					break;
#line 871 "sudoku-saver.c"
				}
				{
					gint j = 0;
#line 125 "../lib/sudoku-saver.vala"
					j = 0;
#line 877 "sudoku-saver.c"
					{
						gboolean _tmp26_ = FALSE;
#line 125 "../lib/sudoku-saver.vala"
						_tmp26_ = TRUE;
#line 125 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 884 "sudoku-saver.c"
							SudokuBoard* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							gint* earmarks = NULL;
							gint* _tmp31_;
							gint earmarks_length1;
							gint _earmarks_size_;
							gboolean _tmp39_ = FALSE;
							gint* _tmp40_;
							gint _tmp40__length1;
							gint _tmp40__length2;
							gint _tmp41_;
							JsonBuilder* _tmp43_;
							JsonBuilder* _tmp44_;
							JsonBuilder* _tmp45_;
							JsonBuilder* _tmp46_;
							JsonBuilder* _tmp47_;
							JsonBuilder* _tmp48_;
							JsonBuilder* _tmp49_;
							JsonBuilder* _tmp50_;
							gint* _tmp51_;
							gint _tmp51__length1;
							gint _tmp51__length2;
							gint _tmp52_;
							JsonBuilder* _tmp53_;
							JsonBuilder* _tmp54_;
							SudokuBoard* _tmp55_;
							gboolean* _tmp56_;
							gint _tmp56__length1;
							gint _tmp56__length2;
							gboolean _tmp57_;
							JsonBuilder* _tmp58_;
							JsonBuilder* _tmp59_;
							gint* _tmp60_;
							gint _tmp60__length1;
							JsonBuilder* _tmp62_;
							JsonBuilder* _tmp63_;
#line 125 "../lib/sudoku-saver.vala"
							if (!_tmp26_) {
#line 924 "sudoku-saver.c"
								gint _tmp27_;
#line 125 "../lib/sudoku-saver.vala"
								_tmp27_ = j;
#line 125 "../lib/sudoku-saver.vala"
								j = _tmp27_ + 1;
#line 930 "sudoku-saver.c"
							}
#line 125 "../lib/sudoku-saver.vala"
							_tmp26_ = FALSE;
#line 125 "../lib/sudoku-saver.vala"
							_tmp28_ = board;
#line 125 "../lib/sudoku-saver.vala"
							_tmp29_ = sudoku_board_get_cols (_tmp28_);
#line 125 "../lib/sudoku-saver.vala"
							_tmp30_ = _tmp29_;
#line 125 "../lib/sudoku-saver.vala"
							if (!(j < _tmp30_)) {
#line 125 "../lib/sudoku-saver.vala"
								break;
#line 944 "sudoku-saver.c"
							}
#line 127 "../lib/sudoku-saver.vala"
							_tmp31_ = g_new0 (gint, 0);
#line 127 "../lib/sudoku-saver.vala"
							earmarks = _tmp31_;
#line 127 "../lib/sudoku-saver.vala"
							earmarks_length1 = 0;
#line 127 "../lib/sudoku-saver.vala"
							_earmarks_size_ = earmarks_length1;
#line 954 "sudoku-saver.c"
							{
								gint k = 0;
#line 128 "../lib/sudoku-saver.vala"
								k = 1;
#line 959 "sudoku-saver.c"
								{
									gboolean _tmp32_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
									_tmp32_ = TRUE;
#line 128 "../lib/sudoku-saver.vala"
									while (TRUE) {
#line 966 "sudoku-saver.c"
										SudokuBoard* _tmp34_;
										gint _tmp35_;
										gint _tmp36_;
										SudokuBoard* _tmp37_;
#line 128 "../lib/sudoku-saver.vala"
										if (!_tmp32_) {
#line 973 "sudoku-saver.c"
											gint _tmp33_;
#line 128 "../lib/sudoku-saver.vala"
											_tmp33_ = k;
#line 128 "../lib/sudoku-saver.vala"
											k = _tmp33_ + 1;
#line 979 "sudoku-saver.c"
										}
#line 128 "../lib/sudoku-saver.vala"
										_tmp32_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
										_tmp34_ = board;
#line 128 "../lib/sudoku-saver.vala"
										_tmp35_ = sudoku_board_get_max_val (_tmp34_);
#line 128 "../lib/sudoku-saver.vala"
										_tmp36_ = _tmp35_;
#line 128 "../lib/sudoku-saver.vala"
										if (!(k <= _tmp36_)) {
#line 128 "../lib/sudoku-saver.vala"
											break;
#line 993 "sudoku-saver.c"
										}
#line 129 "../lib/sudoku-saver.vala"
										_tmp37_ = board;
#line 129 "../lib/sudoku-saver.vala"
										if (sudoku_board_is_earmark_enabled (_tmp37_, i, j, k)) {
#line 999 "sudoku-saver.c"
											gint* _tmp38_;
											gint _tmp38__length1;
#line 130 "../lib/sudoku-saver.vala"
											_tmp38_ = earmarks;
#line 130 "../lib/sudoku-saver.vala"
											_tmp38__length1 = earmarks_length1;
#line 130 "../lib/sudoku-saver.vala"
											_vala_array_add1 (&earmarks, &earmarks_length1, &_earmarks_size_, k);
#line 1008 "sudoku-saver.c"
										}
									}
								}
							}
#line 132 "../lib/sudoku-saver.vala"
							_tmp40_ = board_cells;
#line 132 "../lib/sudoku-saver.vala"
							_tmp40__length1 = board_cells_length1;
#line 132 "../lib/sudoku-saver.vala"
							_tmp40__length2 = board_cells_length2;
#line 132 "../lib/sudoku-saver.vala"
							_tmp41_ = _tmp40_[(i * _tmp40__length2) + j];
#line 132 "../lib/sudoku-saver.vala"
							if (_tmp41_ == 0) {
#line 1023 "sudoku-saver.c"
								gint* _tmp42_;
								gint _tmp42__length1;
#line 132 "../lib/sudoku-saver.vala"
								_tmp42_ = earmarks;
#line 132 "../lib/sudoku-saver.vala"
								_tmp42__length1 = earmarks_length1;
#line 132 "../lib/sudoku-saver.vala"
								_tmp39_ = _tmp42__length1 == 0;
#line 1032 "sudoku-saver.c"
							} else {
#line 132 "../lib/sudoku-saver.vala"
								_tmp39_ = FALSE;
#line 1036 "sudoku-saver.c"
							}
#line 132 "../lib/sudoku-saver.vala"
							if (_tmp39_) {
#line 133 "../lib/sudoku-saver.vala"
								earmarks = (g_free (earmarks), NULL);
#line 133 "../lib/sudoku-saver.vala"
								continue;
#line 1044 "sudoku-saver.c"
							}
#line 135 "../lib/sudoku-saver.vala"
							_tmp43_ = builder;
#line 135 "../lib/sudoku-saver.vala"
							json_builder_begin_object (_tmp43_);
#line 137 "../lib/sudoku-saver.vala"
							_tmp44_ = builder;
#line 137 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp44_, "position");
#line 138 "../lib/sudoku-saver.vala"
							_tmp45_ = builder;
#line 138 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp45_);
#line 139 "../lib/sudoku-saver.vala"
							_tmp46_ = builder;
#line 139 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp46_, (gint64) i);
#line 140 "../lib/sudoku-saver.vala"
							_tmp47_ = builder;
#line 140 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp47_, (gint64) j);
#line 141 "../lib/sudoku-saver.vala"
							_tmp48_ = builder;
#line 141 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp48_);
#line 142 "../lib/sudoku-saver.vala"
							_tmp49_ = builder;
#line 142 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp49_, "value");
#line 143 "../lib/sudoku-saver.vala"
							_tmp50_ = builder;
#line 143 "../lib/sudoku-saver.vala"
							_tmp51_ = board_cells;
#line 143 "../lib/sudoku-saver.vala"
							_tmp51__length1 = board_cells_length1;
#line 143 "../lib/sudoku-saver.vala"
							_tmp51__length2 = board_cells_length2;
#line 143 "../lib/sudoku-saver.vala"
							_tmp52_ = _tmp51_[(i * _tmp51__length2) + j];
#line 143 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp50_, (gint64) _tmp52_);
#line 144 "../lib/sudoku-saver.vala"
							_tmp53_ = builder;
#line 144 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp53_, "fixed");
#line 145 "../lib/sudoku-saver.vala"
							_tmp54_ = builder;
#line 145 "../lib/sudoku-saver.vala"
							_tmp55_ = board;
#line 145 "../lib/sudoku-saver.vala"
							_tmp56_ = _tmp55_->is_fixed;
#line 145 "../lib/sudoku-saver.vala"
							_tmp56__length1 = _tmp55_->is_fixed_length1;
#line 145 "../lib/sudoku-saver.vala"
							_tmp56__length2 = _tmp55_->is_fixed_length2;
#line 145 "../lib/sudoku-saver.vala"
							_tmp57_ = _tmp56_[(i * _tmp56__length2) + j];
#line 145 "../lib/sudoku-saver.vala"
							json_builder_add_boolean_value (_tmp54_, _tmp57_);
#line 146 "../lib/sudoku-saver.vala"
							_tmp58_ = builder;
#line 146 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp58_, "earmarks");
#line 147 "../lib/sudoku-saver.vala"
							_tmp59_ = builder;
#line 147 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp59_);
#line 149 "../lib/sudoku-saver.vala"
							_tmp60_ = earmarks;
#line 149 "../lib/sudoku-saver.vala"
							_tmp60__length1 = earmarks_length1;
#line 1116 "sudoku-saver.c"
							{
								gint* k_collection = NULL;
								gint k_collection_length1 = 0;
								gint _k_collection_size_ = 0;
								gint k_it = 0;
#line 149 "../lib/sudoku-saver.vala"
								k_collection = _tmp60_;
#line 149 "../lib/sudoku-saver.vala"
								k_collection_length1 = _tmp60__length1;
#line 149 "../lib/sudoku-saver.vala"
								for (k_it = 0; k_it < k_collection_length1; k_it = k_it + 1) {
#line 1128 "sudoku-saver.c"
									gint k = 0;
#line 149 "../lib/sudoku-saver.vala"
									k = k_collection[k_it];
#line 1132 "sudoku-saver.c"
									{
										JsonBuilder* _tmp61_;
#line 150 "../lib/sudoku-saver.vala"
										_tmp61_ = builder;
#line 150 "../lib/sudoku-saver.vala"
										json_builder_add_int_value (_tmp61_, (gint64) k);
#line 1139 "sudoku-saver.c"
									}
								}
							}
#line 152 "../lib/sudoku-saver.vala"
							_tmp62_ = builder;
#line 152 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp62_);
#line 154 "../lib/sudoku-saver.vala"
							_tmp63_ = builder;
#line 154 "../lib/sudoku-saver.vala"
							json_builder_end_object (_tmp63_);
#line 125 "../lib/sudoku-saver.vala"
							earmarks = (g_free (earmarks), NULL);
#line 1153 "sudoku-saver.c"
						}
					}
				}
			}
		}
	}
#line 158 "../lib/sudoku-saver.vala"
	_tmp64_ = builder;
#line 158 "../lib/sudoku-saver.vala"
	json_builder_end_array (_tmp64_);
#line 159 "../lib/sudoku-saver.vala"
	_tmp65_ = builder;
#line 159 "../lib/sudoku-saver.vala"
	json_builder_end_object (_tmp65_);
#line 161 "../lib/sudoku-saver.vala"
	_tmp66_ = json_generator_new ();
#line 161 "../lib/sudoku-saver.vala"
	generator = _tmp66_;
#line 162 "../lib/sudoku-saver.vala"
	json_generator_set_pretty (generator, TRUE);
#line 163 "../lib/sudoku-saver.vala"
	_tmp67_ = builder;
#line 163 "../lib/sudoku-saver.vala"
	_tmp68_ = json_builder_get_root (_tmp67_);
#line 163 "../lib/sudoku-saver.vala"
	root = _tmp68_;
#line 164 "../lib/sudoku-saver.vala"
	json_generator_set_root (generator, root);
#line 166 "../lib/sudoku-saver.vala"
	_tmp69_ = json_generator_to_data (generator, NULL);
#line 166 "../lib/sudoku-saver.vala"
	result = _tmp69_;
#line 166 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (root);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (generator);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (builder);
#line 166 "../lib/sudoku-saver.vala"
	board_cells = (g_free (board_cells), NULL);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 166 "../lib/sudoku-saver.vala"
	return result;
#line 1198 "sudoku-saver.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 182 "../lib/sudoku-saver.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1206 "sudoku-saver.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 182 "../lib/sudoku-saver.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1214 "sudoku-saver.c"
}

static SudokuGame*
sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                 const gchar* file_path)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp2_;
	JsonNode* node = NULL;
	JsonParser* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	JsonReader* reader = NULL;
	JsonNode* _tmp6_;
	JsonReader* _tmp7_;
	JsonReader* _tmp8_;
	JsonReader* _tmp9_;
	JsonReader* _tmp47_;
	JsonReader* _tmp48_;
	JsonReader* _tmp49_;
	SudokuBoard* _tmp50_;
	JsonReader* _tmp51_;
	JsonReader* _tmp52_;
	JsonReader* _tmp53_;
	JsonReader* _tmp54_;
	SudokuBoard* _tmp55_;
	JsonReader* _tmp56_;
	const gchar* _tmp57_;
	JsonReader* _tmp58_;
	SudokuBoard* _tmp59_;
	SudokuGame* _tmp60_;
	GError* _inner_error0_ = NULL;
	SudokuGame* result = NULL;
#line 169 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 171 "../lib/sudoku-saver.vala"
	_tmp0_ = json_parser_new ();
#line 171 "../lib/sudoku-saver.vala"
	parser = _tmp0_;
#line 1258 "sudoku-saver.c"
	{
		JsonParser* _tmp1_;
#line 174 "../lib/sudoku-saver.vala"
		_tmp1_ = parser;
#line 174 "../lib/sudoku-saver.vala"
		json_parser_load_from_file (_tmp1_, file_path, &_inner_error0_);
#line 174 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1267 "sudoku-saver.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
#line 172 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 172 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 178 "../lib/sudoku-saver.vala"
		result = NULL;
#line 178 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 178 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 178 "../lib/sudoku-saver.vala"
		return result;
#line 1287 "sudoku-saver.c"
	}
	__finally3:
#line 172 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 172 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 172 "../lib/sudoku-saver.vala"
		return NULL;
#line 1300 "sudoku-saver.c"
	}
#line 181 "../lib/sudoku-saver.vala"
	_tmp2_ = sudoku_board_new (3, 3);
#line 181 "../lib/sudoku-saver.vala"
	board = _tmp2_;
#line 182 "../lib/sudoku-saver.vala"
	_tmp3_ = parser;
#line 182 "../lib/sudoku-saver.vala"
	_tmp4_ = json_parser_get_root (_tmp3_);
#line 182 "../lib/sudoku-saver.vala"
	_tmp5_ = __vala_JsonNode_copy0 (_tmp4_);
#line 182 "../lib/sudoku-saver.vala"
	node = _tmp5_;
#line 183 "../lib/sudoku-saver.vala"
	_tmp6_ = node;
#line 183 "../lib/sudoku-saver.vala"
	_tmp7_ = json_reader_new (_tmp6_);
#line 183 "../lib/sudoku-saver.vala"
	reader = _tmp7_;
#line 184 "../lib/sudoku-saver.vala"
	_tmp8_ = reader;
#line 184 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp8_, "cells");
#line 185 "../lib/sudoku-saver.vala"
	_tmp9_ = reader;
#line 185 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_array (_tmp9_), NULL);
#line 1328 "sudoku-saver.c"
	{
		gint i = 0;
#line 187 "../lib/sudoku-saver.vala"
		i = 0;
#line 1333 "sudoku-saver.c"
		{
			gboolean _tmp10_ = FALSE;
#line 187 "../lib/sudoku-saver.vala"
			_tmp10_ = TRUE;
#line 187 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 1340 "sudoku-saver.c"
				JsonReader* _tmp12_;
				JsonReader* _tmp13_;
				JsonReader* _tmp14_;
				JsonReader* _tmp15_;
				JsonReader* _tmp16_;
				JsonReader* _tmp17_;
				JsonReader* _tmp18_;
				gint row = 0;
				JsonReader* _tmp19_;
				JsonReader* _tmp20_;
				JsonReader* _tmp21_;
				JsonReader* _tmp22_;
				gint col = 0;
				JsonReader* _tmp23_;
				JsonReader* _tmp24_;
				JsonReader* _tmp25_;
				JsonReader* _tmp26_;
				JsonReader* _tmp27_;
				gint val = 0;
				JsonReader* _tmp28_;
				JsonReader* _tmp29_;
				JsonReader* _tmp30_;
				JsonReader* _tmp31_;
				gboolean is_fixed = FALSE;
				JsonReader* _tmp32_;
				JsonReader* _tmp33_;
				JsonReader* _tmp35_;
				JsonReader* _tmp36_;
				JsonReader* _tmp45_;
				JsonReader* _tmp46_;
#line 187 "../lib/sudoku-saver.vala"
				if (!_tmp10_) {
#line 1373 "sudoku-saver.c"
					gint _tmp11_;
#line 187 "../lib/sudoku-saver.vala"
					_tmp11_ = i;
#line 187 "../lib/sudoku-saver.vala"
					i = _tmp11_ + 1;
#line 1379 "sudoku-saver.c"
				}
#line 187 "../lib/sudoku-saver.vala"
				_tmp10_ = FALSE;
#line 187 "../lib/sudoku-saver.vala"
				_tmp12_ = reader;
#line 187 "../lib/sudoku-saver.vala"
				if (!(i < json_reader_count_elements (_tmp12_))) {
#line 187 "../lib/sudoku-saver.vala"
					break;
#line 1389 "sudoku-saver.c"
				}
#line 189 "../lib/sudoku-saver.vala"
				_tmp13_ = reader;
#line 189 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp13_, (guint) i);
#line 191 "../lib/sudoku-saver.vala"
				_tmp14_ = reader;
#line 191 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp14_, "position");
#line 192 "../lib/sudoku-saver.vala"
				_tmp15_ = reader;
#line 192 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp15_), NULL);
#line 193 "../lib/sudoku-saver.vala"
				_tmp16_ = reader;
#line 193 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_count_elements (_tmp16_) == 2, NULL);
#line 194 "../lib/sudoku-saver.vala"
				_tmp17_ = reader;
#line 194 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp17_, (guint) 0);
#line 195 "../lib/sudoku-saver.vala"
				_tmp18_ = reader;
#line 195 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp18_), NULL);
#line 196 "../lib/sudoku-saver.vala"
				_tmp19_ = reader;
#line 196 "../lib/sudoku-saver.vala"
				row = (gint) json_reader_get_int_value (_tmp19_);
#line 197 "../lib/sudoku-saver.vala"
				_tmp20_ = reader;
#line 197 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp20_);
#line 199 "../lib/sudoku-saver.vala"
				_tmp21_ = reader;
#line 199 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp21_, (guint) 1);
#line 200 "../lib/sudoku-saver.vala"
				_tmp22_ = reader;
#line 200 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp22_), NULL);
#line 201 "../lib/sudoku-saver.vala"
				_tmp23_ = reader;
#line 201 "../lib/sudoku-saver.vala"
				col = (gint) json_reader_get_int_value (_tmp23_);
#line 202 "../lib/sudoku-saver.vala"
				_tmp24_ = reader;
#line 202 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp24_);
#line 203 "../lib/sudoku-saver.vala"
				_tmp25_ = reader;
#line 203 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp25_);
#line 205 "../lib/sudoku-saver.vala"
				_tmp26_ = reader;
#line 205 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp26_, "value");
#line 206 "../lib/sudoku-saver.vala"
				_tmp27_ = reader;
#line 206 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp27_), NULL);
#line 207 "../lib/sudoku-saver.vala"
				_tmp28_ = reader;
#line 207 "../lib/sudoku-saver.vala"
				val = (gint) json_reader_get_int_value (_tmp28_);
#line 208 "../lib/sudoku-saver.vala"
				_tmp29_ = reader;
#line 208 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp29_);
#line 210 "../lib/sudoku-saver.vala"
				_tmp30_ = reader;
#line 210 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp30_, "fixed");
#line 211 "../lib/sudoku-saver.vala"
				_tmp31_ = reader;
#line 211 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp31_), NULL);
#line 212 "../lib/sudoku-saver.vala"
				_tmp32_ = reader;
#line 212 "../lib/sudoku-saver.vala"
				is_fixed = json_reader_get_boolean_value (_tmp32_);
#line 213 "../lib/sudoku-saver.vala"
				_tmp33_ = reader;
#line 213 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp33_);
#line 215 "../lib/sudoku-saver.vala"
				if (val != 0) {
#line 1477 "sudoku-saver.c"
					SudokuBoard* _tmp34_;
#line 216 "../lib/sudoku-saver.vala"
					_tmp34_ = board;
#line 216 "../lib/sudoku-saver.vala"
					sudoku_board_insert (_tmp34_, row, col, val, is_fixed);
#line 1483 "sudoku-saver.c"
				}
#line 218 "../lib/sudoku-saver.vala"
				_tmp35_ = reader;
#line 218 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp35_, "earmarks");
#line 219 "../lib/sudoku-saver.vala"
				_tmp36_ = reader;
#line 219 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp36_), NULL);
#line 1493 "sudoku-saver.c"
				{
					gint k = 0;
#line 220 "../lib/sudoku-saver.vala"
					k = 0;
#line 1498 "sudoku-saver.c"
					{
						gboolean _tmp37_ = FALSE;
#line 220 "../lib/sudoku-saver.vala"
						_tmp37_ = TRUE;
#line 220 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 1505 "sudoku-saver.c"
							JsonReader* _tmp39_;
							JsonReader* _tmp40_;
							JsonReader* _tmp41_;
							SudokuBoard* _tmp42_;
							JsonReader* _tmp43_;
							JsonReader* _tmp44_;
#line 220 "../lib/sudoku-saver.vala"
							if (!_tmp37_) {
#line 1514 "sudoku-saver.c"
								gint _tmp38_;
#line 220 "../lib/sudoku-saver.vala"
								_tmp38_ = k;
#line 220 "../lib/sudoku-saver.vala"
								k = _tmp38_ + 1;
#line 1520 "sudoku-saver.c"
							}
#line 220 "../lib/sudoku-saver.vala"
							_tmp37_ = FALSE;
#line 220 "../lib/sudoku-saver.vala"
							_tmp39_ = reader;
#line 220 "../lib/sudoku-saver.vala"
							if (!(k < json_reader_count_elements (_tmp39_))) {
#line 220 "../lib/sudoku-saver.vala"
								break;
#line 1530 "sudoku-saver.c"
							}
#line 222 "../lib/sudoku-saver.vala"
							_tmp40_ = reader;
#line 222 "../lib/sudoku-saver.vala"
							json_reader_read_element (_tmp40_, (guint) k);
#line 223 "../lib/sudoku-saver.vala"
							_tmp41_ = reader;
#line 223 "../lib/sudoku-saver.vala"
							g_return_val_if_fail (json_reader_is_value (_tmp41_), NULL);
#line 224 "../lib/sudoku-saver.vala"
							_tmp42_ = board;
#line 224 "../lib/sudoku-saver.vala"
							_tmp43_ = reader;
#line 224 "../lib/sudoku-saver.vala"
							sudoku_board_enable_earmark (_tmp42_, row, col, (gint) json_reader_get_int_value (_tmp43_));
#line 225 "../lib/sudoku-saver.vala"
							_tmp44_ = reader;
#line 225 "../lib/sudoku-saver.vala"
							json_reader_end_element (_tmp44_);
#line 1550 "sudoku-saver.c"
						}
					}
				}
#line 227 "../lib/sudoku-saver.vala"
				_tmp45_ = reader;
#line 227 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp45_);
#line 229 "../lib/sudoku-saver.vala"
				_tmp46_ = reader;
#line 229 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp46_);
#line 1562 "sudoku-saver.c"
			}
		}
	}
#line 231 "../lib/sudoku-saver.vala"
	_tmp47_ = reader;
#line 231 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp47_);
#line 233 "../lib/sudoku-saver.vala"
	_tmp48_ = reader;
#line 233 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp48_, "time_elapsed");
#line 234 "../lib/sudoku-saver.vala"
	_tmp49_ = reader;
#line 234 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp49_), NULL);
#line 235 "../lib/sudoku-saver.vala"
	_tmp50_ = board;
#line 235 "../lib/sudoku-saver.vala"
	_tmp51_ = reader;
#line 235 "../lib/sudoku-saver.vala"
	sudoku_board_set_previous_played_time (_tmp50_, json_reader_get_double_value (_tmp51_));
#line 236 "../lib/sudoku-saver.vala"
	_tmp52_ = reader;
#line 236 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp52_);
#line 238 "../lib/sudoku-saver.vala"
	_tmp53_ = reader;
#line 238 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp53_, "difficulty_category");
#line 239 "../lib/sudoku-saver.vala"
	_tmp54_ = reader;
#line 239 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp54_), NULL);
#line 240 "../lib/sudoku-saver.vala"
	_tmp55_ = board;
#line 240 "../lib/sudoku-saver.vala"
	_tmp56_ = reader;
#line 240 "../lib/sudoku-saver.vala"
	_tmp57_ = json_reader_get_string_value (_tmp56_);
#line 240 "../lib/sudoku-saver.vala"
	sudoku_board_set_difficulty_category (_tmp55_, difficulty_category_from_string (_tmp57_));
#line 241 "../lib/sudoku-saver.vala"
	_tmp58_ = reader;
#line 241 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp58_);
#line 243 "../lib/sudoku-saver.vala"
	_tmp59_ = board;
#line 243 "../lib/sudoku-saver.vala"
	_tmp60_ = sudoku_game_new (_tmp59_);
#line 243 "../lib/sudoku-saver.vala"
	result = _tmp60_;
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (reader);
#line 243 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (node);
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (parser);
#line 243 "../lib/sudoku-saver.vala"
	return result;
#line 1624 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_savegame_file (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__savegame_file;
#line 26 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	return result;
#line 1638 "sudoku-saver.c"
}

static void
sudoku_saver_set_savegame_file (const gchar* value)
{
	gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 26 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__savegame_file);
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 1651 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_finishgame_dir (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__finishgame_dir;
#line 27 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	return result;
#line 1665 "sudoku-saver.c"
}

static void
sudoku_saver_set_finishgame_dir (const gchar* value)
{
	gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 27 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__finishgame_dir);
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp0_;
#line 1678 "sudoku-saver.c"
}

static void
sudoku_saver_class_init (SudokuSaverClass * klass,
                         gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 24 "../lib/sudoku-saver.vala"
	sudoku_saver_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_saver_get_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_saver_set_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_saver_finalize;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp1_ = g_strdup ("");
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp1_;
#line 1703 "sudoku-saver.c"
}

static void
sudoku_saver_instance_init (SudokuSaver * self,
                            gpointer klass)
{
}

static void
sudoku_saver_finalize (GObject * obj)
{
	SudokuSaver * self;
#line 24 "../lib/sudoku-saver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (sudoku_saver_parent_class)->finalize (obj);
#line 1720 "sudoku-saver.c"
}

GType
sudoku_saver_get_type (void)
{
	static volatile gsize sudoku_saver_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_saver_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuSaverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_saver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuSaver), 0, (GInstanceInitFunc) sudoku_saver_instance_init, NULL };
		GType sudoku_saver_type_id;
		sudoku_saver_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuSaver", &g_define_type_info, 0);
		g_once_init_leave (&sudoku_saver_type_id__volatile, sudoku_saver_type_id);
	}
	return sudoku_saver_type_id__volatile;
}

static void
_vala_sudoku_saver_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1746 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1752 "sudoku-saver.c"
	}
}

static void
_vala_sudoku_saver_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1766 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1772 "sudoku-saver.c"
	}
}

