/* print-dialog.c generated by valac 0.46.0, the Vala compiler
 * generated from print-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>

#define TYPE_PRINT_DIALOG (print_dialog_get_type ())
#define PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PRINT_DIALOG, PrintDialog))
#define PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PRINT_DIALOG, PrintDialogClass))
#define IS_PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PRINT_DIALOG))
#define IS_PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PRINT_DIALOG))
#define PRINT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PRINT_DIALOG, PrintDialogClass))

typedef struct _PrintDialog PrintDialog;
typedef struct _PrintDialogClass PrintDialogClass;
typedef struct _PrintDialogPrivate PrintDialogPrivate;
enum  {
	PRINT_DIALOG_0_PROPERTY,
	PRINT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* print_dialog_properties[PRINT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;

#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PrintDialog {
	GtkDialog parent_instance;
	PrintDialogPrivate * priv;
};

struct _PrintDialogClass {
	GtkDialogClass parent_class;
};

struct _PrintDialogPrivate {
	SudokuSaver* saver;
	GSettings* settings;
	GtkButton* print_button;
	GtkBox* print_box;
	GtkSpinButton* n_sudokus_button;
	GtkRadioButton* easy_radio_button;
	GtkRadioButton* medium_radio_button;
	GtkRadioButton* hard_radio_button;
	GtkRadioButton* very_hard_radio_button;
	GtkRevealer* revealer;
	GtkSpinner* spinner;
	GCancellable* cancellable;
};

struct _Block6Data {
	int _ref_count_;
	PrintDialog* self;
	gchar* key_name;
	GtkAdjustment* action;
};

static gint PrintDialog_private_offset;
static gpointer print_dialog_parent_class = NULL;

GType print_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrintDialog, g_object_unref)
#define PRINT_DIALOG_DIFFICULTY_KEY_NAME "print-multiple-sudoku-difficulty"
PrintDialog* print_dialog_new (SudokuSaver* saver,
                               GtkWindow* window);
PrintDialog* print_dialog_construct (GType object_type,
                                     SudokuSaver* saver,
                                     GtkWindow* window);
static void __lambda23_ (PrintDialog* self,
                  gint response_id);
static void ___lambda23__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void print_dialog_wrap_adjustment (PrintDialog* self,
                                   const gchar* key_name,
                                   GtkAdjustment* action);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda24_ (Block6Data* _data6_);
static void ___lambda24__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
gboolean print_dialog_start_spinner_cb (PrintDialog* self);
static void print_dialog_real_response (GtkDialog* base,
                                 gint response);
static void __lambda22_ (PrintDialog* self,
                  GObject* obj,
                  GAsyncResult* res);
GType sudoku_printer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPrinter, g_object_unref)
SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   GtkWindow* window);
SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         GtkWindow* window);
GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
static void ___lambda22__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void print_dialog_finalize (GObject * obj);

static inline gpointer
print_dialog_get_instance_private (PrintDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PrintDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/print-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "print-dialog.c"
}

static void
__lambda23_ (PrintDialog* self,
             gint response_id)
{
	gboolean _tmp0_ = FALSE;
#line 58 "../src/print-dialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_CANCEL)) {
#line 58 "../src/print-dialog.vala"
		_tmp0_ = TRUE;
#line 164 "print-dialog.c"
	} else {
#line 58 "../src/print-dialog.vala"
		_tmp0_ = response_id == ((gint) GTK_RESPONSE_DELETE_EVENT);
#line 168 "print-dialog.c"
	}
#line 58 "../src/print-dialog.vala"
	if (_tmp0_) {
#line 172 "print-dialog.c"
		GCancellable* _tmp1_;
#line 59 "../src/print-dialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 59 "../src/print-dialog.vala"
		g_cancellable_cancel (_tmp1_);
#line 178 "print-dialog.c"
	}
}

static void
___lambda23__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 57 "../src/print-dialog.vala"
	__lambda23_ ((PrintDialog*) self, response_id);
#line 189 "print-dialog.c"
}

PrintDialog*
print_dialog_construct (GType object_type,
                        SudokuSaver* saver,
                        GtkWindow* window)
{
	PrintDialog * self = NULL;
	SudokuSaver* _tmp0_;
	GSettings* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkRevealer* _tmp3_;
	GtkRevealer* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkWidget* _tmp7_;
	GtkRevealer* _tmp8_;
	DifficultyCategory saved_difficulty = 0;
	GSettings* _tmp9_;
	DifficultyCategory _tmp10_;
	GtkSpinButton* _tmp18_;
	GtkAdjustment* _tmp19_;
#line 50 "../src/print-dialog.vala"
	g_return_val_if_fail (saver != NULL, NULL);
#line 50 "../src/print-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 52 "../src/print-dialog.vala"
	self = (PrintDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 54 "../src/print-dialog.vala"
	_tmp0_ = _g_object_ref0 (saver);
#line 54 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 54 "../src/print-dialog.vala"
	self->priv->saver = _tmp0_;
#line 55 "../src/print-dialog.vala"
	_tmp1_ = g_settings_new ("org.gnome.Sudoku");
#line 55 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 55 "../src/print-dialog.vala"
	self->priv->settings = _tmp1_;
#line 57 "../src/print-dialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda23__gtk_dialog_response, self, 0);
#line 62 "../src/print-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 64 "../src/print-dialog.vala"
	_tmp2_ = (GtkSpinner*) gtk_spinner_new ();
#line 64 "../src/print-dialog.vala"
	g_object_ref_sink (_tmp2_);
#line 64 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 64 "../src/print-dialog.vala"
	self->priv->spinner = _tmp2_;
#line 65 "../src/print-dialog.vala"
	_tmp3_ = (GtkRevealer*) gtk_revealer_new ();
#line 65 "../src/print-dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 65 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->revealer);
#line 65 "../src/print-dialog.vala"
	self->priv->revealer = _tmp3_;
#line 66 "../src/print-dialog.vala"
	_tmp4_ = self->priv->revealer;
#line 66 "../src/print-dialog.vala"
	_tmp5_ = self->priv->spinner;
#line 66 "../src/print-dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 67 "../src/print-dialog.vala"
	_tmp6_ = self->priv->revealer;
#line 67 "../src/print-dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 68 "../src/print-dialog.vala"
	_tmp7_ = gtk_dialog_get_header_bar ((GtkDialog*) self);
#line 68 "../src/print-dialog.vala"
	_tmp8_ = self->priv->revealer;
#line 68 "../src/print-dialog.vala"
	gtk_header_bar_pack_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_header_bar_get_type (), GtkHeaderBar), (GtkWidget*) _tmp8_);
#line 70 "../src/print-dialog.vala"
	_tmp9_ = self->priv->settings;
#line 70 "../src/print-dialog.vala"
	saved_difficulty = (DifficultyCategory) g_settings_get_enum (_tmp9_, PRINT_DIALOG_DIFFICULTY_KEY_NAME);
#line 71 "../src/print-dialog.vala"
	_tmp10_ = saved_difficulty;
#line 71 "../src/print-dialog.vala"
	if (_tmp10_ == DIFFICULTY_CATEGORY_EASY) {
#line 274 "print-dialog.c"
		GtkRadioButton* _tmp11_;
#line 72 "../src/print-dialog.vala"
		_tmp11_ = self->priv->easy_radio_button;
#line 72 "../src/print-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp11_, TRUE);
#line 280 "print-dialog.c"
	} else {
		DifficultyCategory _tmp12_;
#line 73 "../src/print-dialog.vala"
		_tmp12_ = saved_difficulty;
#line 73 "../src/print-dialog.vala"
		if (_tmp12_ == DIFFICULTY_CATEGORY_MEDIUM) {
#line 287 "print-dialog.c"
			GtkRadioButton* _tmp13_;
#line 74 "../src/print-dialog.vala"
			_tmp13_ = self->priv->medium_radio_button;
#line 74 "../src/print-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp13_, TRUE);
#line 293 "print-dialog.c"
		} else {
			DifficultyCategory _tmp14_;
#line 75 "../src/print-dialog.vala"
			_tmp14_ = saved_difficulty;
#line 75 "../src/print-dialog.vala"
			if (_tmp14_ == DIFFICULTY_CATEGORY_HARD) {
#line 300 "print-dialog.c"
				GtkRadioButton* _tmp15_;
#line 76 "../src/print-dialog.vala"
				_tmp15_ = self->priv->hard_radio_button;
#line 76 "../src/print-dialog.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp15_, TRUE);
#line 306 "print-dialog.c"
			} else {
				DifficultyCategory _tmp16_;
#line 77 "../src/print-dialog.vala"
				_tmp16_ = saved_difficulty;
#line 77 "../src/print-dialog.vala"
				if (_tmp16_ == DIFFICULTY_CATEGORY_VERY_HARD) {
#line 313 "print-dialog.c"
					GtkRadioButton* _tmp17_;
#line 78 "../src/print-dialog.vala"
					_tmp17_ = self->priv->very_hard_radio_button;
#line 78 "../src/print-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp17_, TRUE);
#line 319 "print-dialog.c"
				} else {
#line 80 "../src/print-dialog.vala"
					g_assert_not_reached ();
#line 323 "print-dialog.c"
				}
			}
		}
	}
#line 82 "../src/print-dialog.vala"
	_tmp18_ = self->priv->n_sudokus_button;
#line 82 "../src/print-dialog.vala"
	_tmp19_ = gtk_spin_button_get_adjustment (_tmp18_);
#line 82 "../src/print-dialog.vala"
	print_dialog_wrap_adjustment (self, "print-multiple-sudokus-to-print", _tmp19_);
#line 50 "../src/print-dialog.vala"
	return self;
#line 336 "print-dialog.c"
}

PrintDialog*
print_dialog_new (SudokuSaver* saver,
                  GtkWindow* window)
{
#line 50 "../src/print-dialog.vala"
	return print_dialog_construct (TYPE_PRINT_DIALOG, saver, window);
#line 345 "print-dialog.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 85 "../src/print-dialog.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 85 "../src/print-dialog.vala"
	return _data6_;
#line 355 "print-dialog.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 85 "../src/print-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 365 "print-dialog.c"
		PrintDialog* self;
#line 85 "../src/print-dialog.vala"
		self = _data6_->self;
#line 85 "../src/print-dialog.vala"
		_g_free0 (_data6_->key_name);
#line 85 "../src/print-dialog.vala"
		_g_object_unref0 (_data6_->action);
#line 85 "../src/print-dialog.vala"
		_g_object_unref0 (self);
#line 85 "../src/print-dialog.vala"
		g_slice_free (Block6Data, _data6_);
#line 377 "print-dialog.c"
	}
}

static void
__lambda24_ (Block6Data* _data6_)
{
	PrintDialog* self;
	GSettings* _tmp0_;
#line 88 "../src/print-dialog.vala"
	self = _data6_->self;
#line 88 "../src/print-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 88 "../src/print-dialog.vala"
	g_settings_set_int (_tmp0_, _data6_->key_name, (gint) gtk_adjustment_get_value (_data6_->action));
#line 392 "print-dialog.c"
}

static void
___lambda24__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 88 "../src/print-dialog.vala"
	__lambda24_ (self);
#line 401 "print-dialog.c"
}

static void
print_dialog_wrap_adjustment (PrintDialog* self,
                              const gchar* key_name,
                              GtkAdjustment* action)
{
	Block6Data* _data6_;
	gchar* _tmp0_;
	GtkAdjustment* _tmp1_;
	GSettings* _tmp2_;
#line 85 "../src/print-dialog.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/print-dialog.vala"
	g_return_if_fail (key_name != NULL);
#line 85 "../src/print-dialog.vala"
	g_return_if_fail (action != NULL);
#line 85 "../src/print-dialog.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 85 "../src/print-dialog.vala"
	_data6_->_ref_count_ = 1;
#line 85 "../src/print-dialog.vala"
	_data6_->self = g_object_ref (self);
#line 85 "../src/print-dialog.vala"
	_tmp0_ = g_strdup (key_name);
#line 85 "../src/print-dialog.vala"
	_g_free0 (_data6_->key_name);
#line 85 "../src/print-dialog.vala"
	_data6_->key_name = _tmp0_;
#line 85 "../src/print-dialog.vala"
	_tmp1_ = _g_object_ref0 (action);
#line 85 "../src/print-dialog.vala"
	_g_object_unref0 (_data6_->action);
#line 85 "../src/print-dialog.vala"
	_data6_->action = _tmp1_;
#line 87 "../src/print-dialog.vala"
	_tmp2_ = self->priv->settings;
#line 87 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data6_->action, (gdouble) g_settings_get_int (_tmp2_, _data6_->key_name));
#line 88 "../src/print-dialog.vala"
	g_signal_connect_data (_data6_->action, "value-changed", (GCallback) ___lambda24__gtk_adjustment_value_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 85 "../src/print-dialog.vala"
	block6_data_unref (_data6_);
#line 85 "../src/print-dialog.vala"
	_data6_ = NULL;
#line 447 "print-dialog.c"
}

gboolean
print_dialog_start_spinner_cb (PrintDialog* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkRevealer* _tmp3_;
	gboolean result = FALSE;
#line 91 "../src/print-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/print-dialog.vala"
	_tmp0_ = self->priv->revealer;
#line 93 "../src/print-dialog.vala"
	gtk_revealer_set_transition_type (_tmp0_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 94 "../src/print-dialog.vala"
	_tmp1_ = self->priv->revealer;
#line 94 "../src/print-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 95 "../src/print-dialog.vala"
	_tmp2_ = self->priv->spinner;
#line 95 "../src/print-dialog.vala"
	gtk_spinner_start (_tmp2_);
#line 96 "../src/print-dialog.vala"
	_tmp3_ = self->priv->revealer;
#line 96 "../src/print-dialog.vala"
	gtk_revealer_set_reveal_child (_tmp3_, TRUE);
#line 97 "../src/print-dialog.vala"
	result = G_SOURCE_REMOVE;
#line 97 "../src/print-dialog.vala"
	return result;
#line 480 "print-dialog.c"
}

static void
__lambda22_ (PrintDialog* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 130 "../src/print-dialog.vala"
	g_return_if_fail (res != NULL);
#line 491 "print-dialog.c"
	{
		GeeList* boards = NULL;
		GeeList* _tmp0_;
		GtkSpinner* _tmp1_;
		GtkRevealer* _tmp2_;
		SudokuPrinter* printer = NULL;
		SudokuPrinter* _tmp3_;
		SudokuPrinter* _tmp4_;
#line 133 "../src/print-dialog.vala"
		_tmp0_ = sudoku_generator_generate_boards_finish (res, &_inner_error0_);
#line 133 "../src/print-dialog.vala"
		boards = _tmp0_;
#line 133 "../src/print-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 508 "print-dialog.c"
				goto __catch4_g_thread_error;
			}
#line 133 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 513 "print-dialog.c"
				goto __catch4_g_io_error;
			}
#line 133 "../src/print-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 133 "../src/print-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 133 "../src/print-dialog.vala"
			return;
#line 522 "print-dialog.c"
		}
#line 135 "../src/print-dialog.vala"
		_tmp1_ = self->priv->spinner;
#line 135 "../src/print-dialog.vala"
		gtk_spinner_stop (_tmp1_);
#line 136 "../src/print-dialog.vala"
		_tmp2_ = self->priv->revealer;
#line 136 "../src/print-dialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 138 "../src/print-dialog.vala"
		_tmp3_ = sudoku_printer_new (boards, (GtkWindow*) self);
#line 138 "../src/print-dialog.vala"
		printer = _tmp3_;
#line 139 "../src/print-dialog.vala"
		_tmp4_ = printer;
#line 139 "../src/print-dialog.vala"
		if (sudoku_printer_print_sudoku (_tmp4_) == GTK_PRINT_OPERATION_RESULT_APPLY) {
#line 540 "print-dialog.c"
			{
				GeeList* _board_list = NULL;
				GeeList* _tmp5_;
				gint _board_size = 0;
				GeeList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint _board_index = 0;
#line 141 "../src/print-dialog.vala"
				_tmp5_ = _g_object_ref0 (boards);
#line 141 "../src/print-dialog.vala"
				_board_list = _tmp5_;
#line 141 "../src/print-dialog.vala"
				_tmp6_ = _board_list;
#line 141 "../src/print-dialog.vala"
				_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 141 "../src/print-dialog.vala"
				_tmp8_ = _tmp7_;
#line 141 "../src/print-dialog.vala"
				_board_size = _tmp8_;
#line 141 "../src/print-dialog.vala"
				_board_index = -1;
#line 141 "../src/print-dialog.vala"
				while (TRUE) {
#line 565 "print-dialog.c"
					SudokuBoard* board = NULL;
					GeeList* _tmp9_;
					gpointer _tmp10_;
					SudokuSaver* _tmp11_;
					SudokuBoard* _tmp12_;
					SudokuGame* _tmp13_;
					SudokuGame* _tmp14_;
#line 141 "../src/print-dialog.vala"
					_board_index = _board_index + 1;
#line 141 "../src/print-dialog.vala"
					if (!(_board_index < _board_size)) {
#line 141 "../src/print-dialog.vala"
						break;
#line 579 "print-dialog.c"
					}
#line 141 "../src/print-dialog.vala"
					_tmp9_ = _board_list;
#line 141 "../src/print-dialog.vala"
					_tmp10_ = gee_list_get (_tmp9_, _board_index);
#line 141 "../src/print-dialog.vala"
					board = (SudokuBoard*) _tmp10_;
#line 142 "../src/print-dialog.vala"
					_tmp11_ = self->priv->saver;
#line 142 "../src/print-dialog.vala"
					_tmp12_ = board;
#line 142 "../src/print-dialog.vala"
					_tmp13_ = sudoku_game_new (_tmp12_);
#line 142 "../src/print-dialog.vala"
					_tmp14_ = _tmp13_;
#line 142 "../src/print-dialog.vala"
					sudoku_saver_add_game_to_finished (_tmp11_, _tmp14_, FALSE);
#line 142 "../src/print-dialog.vala"
					_g_object_unref0 (_tmp14_);
#line 141 "../src/print-dialog.vala"
					_g_object_unref0 (board);
#line 601 "print-dialog.c"
				}
#line 141 "../src/print-dialog.vala"
				_g_object_unref0 (_board_list);
#line 605 "print-dialog.c"
			}
		}
#line 131 "../src/print-dialog.vala"
		_g_object_unref0 (printer);
#line 131 "../src/print-dialog.vala"
		_g_object_unref0 (boards);
#line 612 "print-dialog.c"
	}
	goto __finally4;
	__catch4_g_thread_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
#line 131 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 131 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 147 "../src/print-dialog.vala"
		_tmp15_ = e->message;
#line 147 "../src/print-dialog.vala"
		g_error ("print-dialog.vala:147: Thread error: %s\n", _tmp15_);
#line 131 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 629 "print-dialog.c"
	}
	goto __finally4;
	__catch4_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
#line 131 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 131 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 151 "../src/print-dialog.vala"
		_tmp16_ = e;
#line 151 "../src/print-dialog.vala"
		if (!g_error_matches (_tmp16_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 644 "print-dialog.c"
			GError* _tmp17_;
			const gchar* _tmp18_;
#line 152 "../src/print-dialog.vala"
			_tmp17_ = e;
#line 152 "../src/print-dialog.vala"
			_tmp18_ = _tmp17_->message;
#line 152 "../src/print-dialog.vala"
			g_warning ("print-dialog.vala:152: Error: %s\n", _tmp18_);
#line 653 "print-dialog.c"
		}
#line 131 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 657 "print-dialog.c"
	}
	__finally4:
#line 131 "../src/print-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/print-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/print-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 131 "../src/print-dialog.vala"
		return;
#line 668 "print-dialog.c"
	}
#line 155 "../src/print-dialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 672 "print-dialog.c"
}

static void
___lambda22__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 130 "../src/print-dialog.vala"
	__lambda22_ ((PrintDialog*) self, source_object, res);
#line 130 "../src/print-dialog.vala"
	g_object_unref (self);
#line 684 "print-dialog.c"
}

static void
print_dialog_real_response (GtkDialog* base,
                            gint response)
{
	PrintDialog * self;
	gint nsudokus = 0;
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_;
	DifficultyCategory level = 0;
	GtkRadioButton* _tmp2_;
	GSettings* _tmp6_;
	DifficultyCategory _tmp7_;
	GtkButton* _tmp8_;
	GtkBox* _tmp9_;
	GCancellable* _tmp10_;
	DifficultyCategory _tmp11_;
	GCancellable* _tmp12_;
#line 100 "../src/print-dialog.vala"
	self = (PrintDialog*) base;
#line 102 "../src/print-dialog.vala"
	if (response != ((gint) GTK_RESPONSE_OK)) {
#line 104 "../src/print-dialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 105 "../src/print-dialog.vala"
		return;
#line 712 "print-dialog.c"
	}
#line 108 "../src/print-dialog.vala"
	_tmp0_ = self->priv->n_sudokus_button;
#line 108 "../src/print-dialog.vala"
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
#line 108 "../src/print-dialog.vala"
	nsudokus = (gint) gtk_adjustment_get_value (_tmp1_);
#line 111 "../src/print-dialog.vala"
	_tmp2_ = self->priv->easy_radio_button;
#line 111 "../src/print-dialog.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp2_)) {
#line 112 "../src/print-dialog.vala"
		level = DIFFICULTY_CATEGORY_EASY;
#line 726 "print-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
#line 113 "../src/print-dialog.vala"
		_tmp3_ = self->priv->medium_radio_button;
#line 113 "../src/print-dialog.vala"
		if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_)) {
#line 114 "../src/print-dialog.vala"
			level = DIFFICULTY_CATEGORY_MEDIUM;
#line 735 "print-dialog.c"
		} else {
			GtkRadioButton* _tmp4_;
#line 115 "../src/print-dialog.vala"
			_tmp4_ = self->priv->hard_radio_button;
#line 115 "../src/print-dialog.vala"
			if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_)) {
#line 116 "../src/print-dialog.vala"
				level = DIFFICULTY_CATEGORY_HARD;
#line 744 "print-dialog.c"
			} else {
				GtkRadioButton* _tmp5_;
#line 117 "../src/print-dialog.vala"
				_tmp5_ = self->priv->very_hard_radio_button;
#line 117 "../src/print-dialog.vala"
				if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_)) {
#line 118 "../src/print-dialog.vala"
					level = DIFFICULTY_CATEGORY_VERY_HARD;
#line 753 "print-dialog.c"
				} else {
#line 120 "../src/print-dialog.vala"
					g_assert_not_reached ();
#line 757 "print-dialog.c"
				}
			}
		}
	}
#line 122 "../src/print-dialog.vala"
	_tmp6_ = self->priv->settings;
#line 122 "../src/print-dialog.vala"
	_tmp7_ = level;
#line 122 "../src/print-dialog.vala"
	g_settings_set_enum (_tmp6_, PRINT_DIALOG_DIFFICULTY_KEY_NAME, (gint) _tmp7_);
#line 124 "../src/print-dialog.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 3, (GSourceFunc) print_dialog_start_spinner_cb, g_object_ref (self), g_object_unref);
#line 126 "../src/print-dialog.vala"
	_tmp8_ = self->priv->print_button;
#line 126 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 127 "../src/print-dialog.vala"
	_tmp9_ = self->priv->print_box;
#line 127 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 129 "../src/print-dialog.vala"
	_tmp10_ = g_cancellable_new ();
#line 129 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 129 "../src/print-dialog.vala"
	self->priv->cancellable = _tmp10_;
#line 130 "../src/print-dialog.vala"
	_tmp11_ = level;
#line 130 "../src/print-dialog.vala"
	_tmp12_ = self->priv->cancellable;
#line 130 "../src/print-dialog.vala"
	sudoku_generator_generate_boards_async (nsudokus, _tmp11_, _tmp12_, ___lambda22__gasync_ready_callback, g_object_ref (self));
#line 790 "print-dialog.c"
}

static void
print_dialog_class_init (PrintDialogClass * klass,
                         gpointer klass_data)
{
#line 23 "../src/print-dialog.vala"
	print_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/print-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PrintDialog_private_offset);
#line 23 "../src/print-dialog.vala"
	((GtkDialogClass *) klass)->response = (void (*) (GtkDialog*, gint)) print_dialog_real_response;
#line 23 "../src/print-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = print_dialog_finalize;
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/print-dialog.ui");
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "print_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, print_button));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "print_box", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, print_box));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "n_sudokus_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, n_sudokus_button));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, easy_radio_button));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, medium_radio_button));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, hard_radio_button));
#line 23 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_radio_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, very_hard_radio_button));
#line 821 "print-dialog.c"
}

static void
print_dialog_instance_init (PrintDialog * self,
                            gpointer klass)
{
#line 23 "../src/print-dialog.vala"
	self->priv = print_dialog_get_instance_private (self);
#line 23 "../src/print-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 832 "print-dialog.c"
}

static void
print_dialog_finalize (GObject * obj)
{
	PrintDialog * self;
#line 23 "../src/print-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_DIALOG, PrintDialog);
#line 25 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 26 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->print_button);
#line 31 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->print_box);
#line 33 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->n_sudokus_button);
#line 35 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->easy_radio_button);
#line 37 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->medium_radio_button);
#line 39 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->hard_radio_button);
#line 41 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->very_hard_radio_button);
#line 43 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->revealer);
#line 44 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 46 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 23 "../src/print-dialog.vala"
	G_OBJECT_CLASS (print_dialog_parent_class)->finalize (obj);
#line 867 "print-dialog.c"
}

GType
print_dialog_get_type (void)
{
	static volatile gsize print_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&print_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrintDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintDialog), 0, (GInstanceInitFunc) print_dialog_instance_init, NULL };
		GType print_dialog_type_id;
		print_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PrintDialog", &g_define_type_info, 0);
		PrintDialog_private_offset = g_type_add_instance_private (print_dialog_type_id, sizeof (PrintDialogPrivate));
		g_once_init_leave (&print_dialog_type_id__volatile, print_dialog_type_id);
	}
	return print_dialog_type_id__volatile;
}

