/* sudoku-printer.c generated by valac 0.46.0, the Vala compiler
 * generated from sudoku-printer.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
typedef struct _SudokuPrinterPrivate SudokuPrinterPrivate;
enum  {
	SUDOKU_PRINTER_0_PROPERTY,
	SUDOKU_PRINTER_NUM_PROPERTIES
};
static GParamSpec* sudoku_printer_properties[SUDOKU_PRINTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _SudokuPrinter {
	GObject parent_instance;
	SudokuPrinterPrivate * priv;
};

struct _SudokuPrinterClass {
	GObjectClass parent_class;
};

struct _SudokuPrinterPrivate {
	GeeList* boards;
	GtkWindow* window;
	gint margin;
	gint n_sudokus;
	GtkPrintOperation* print_op;
};

static gint SudokuPrinter_private_offset;
static gpointer sudoku_printer_parent_class = NULL;

GType sudoku_printer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPrinter, g_object_unref)
#define SUDOKU_PRINTER_SUDOKUS_PER_PAGE 2
GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   GtkWindow* window);
SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         GtkWindow* window);
static void sudoku_printer_begin_print_cb (SudokuPrinter* self,
                                    GtkPrintOperation* operation,
                                    GtkPrintContext* context);
static void _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                     GtkPrintContext* context,
                                                                     gpointer self);
static void sudoku_printer_draw_page_cb (SudokuPrinter* self,
                                  GtkPrintOperation* operation,
                                  GtkPrintContext* context,
                                  gint page_nr);
static void _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                                 GtkPrintContext* context,
                                                                 gint page_nr,
                                                                 gpointer self);
static gdouble sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                                 gdouble width,
                                                 gdouble height,
                                                 gint margin);
static void sudoku_printer_draw_sudoku (SudokuPrinter* self,
                                 cairo_t* cr,
                                 SudokuBoard* sudoku_board,
                                 gdouble size,
                                 gdouble offset_x,
                                 gdouble offset_y);
static void sudoku_printer_finalize (GObject * obj);

static inline gpointer
sudoku_printer_get_instance_private (SudokuPrinter* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPrinter_private_offset);
}

GtkPrintOperationResult
sudoku_printer_print_sudoku (SudokuPrinter* self)
{
	GError* _inner_error0_ = NULL;
	GtkPrintOperationResult result = 0;
#line 36 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 126 "sudoku-printer.c"
	{
		GtkPrintOperationResult _result_ = 0;
		GtkPrintOperation* _tmp0_;
		GtkWindow* _tmp1_;
#line 40 "../src/sudoku-printer.vala"
		_tmp0_ = self->priv->print_op;
#line 40 "../src/sudoku-printer.vala"
		_tmp1_ = self->priv->window;
#line 40 "../src/sudoku-printer.vala"
		_result_ = gtk_print_operation_run (_tmp0_, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, _tmp1_, &_inner_error0_);
#line 40 "../src/sudoku-printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "sudoku-printer.c"
			goto __catch5_g_error;
		}
#line 41 "../src/sudoku-printer.vala"
		result = _result_;
#line 41 "../src/sudoku-printer.vala"
		return result;
#line 146 "sudoku-printer.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkMessageDialog* _tmp7_;
		GtkMessageDialog* _tmp8_;
#line 38 "../src/sudoku-printer.vala"
		e = _inner_error0_;
#line 38 "../src/sudoku-printer.vala"
		_inner_error0_ = NULL;
#line 45 "../src/sudoku-printer.vala"
		_tmp2_ = self->priv->window;
#line 45 "../src/sudoku-printer.vala"
		_tmp3_ = e;
#line 45 "../src/sudoku-printer.vala"
		_tmp4_ = _tmp3_->message;
#line 45 "../src/sudoku-printer.vala"
		_tmp5_ = g_strdup_printf ("%s\n%s", _ ("Error printing file:"), _tmp4_);
#line 45 "../src/sudoku-printer.vala"
		_tmp6_ = _tmp5_;
#line 45 "../src/sudoku-printer.vala"
		_tmp7_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", _tmp6_);
#line 45 "../src/sudoku-printer.vala"
		g_object_ref_sink (_tmp7_);
#line 45 "../src/sudoku-printer.vala"
		_tmp8_ = _tmp7_;
#line 45 "../src/sudoku-printer.vala"
		gtk_dialog_run ((GtkDialog*) _tmp8_);
#line 45 "../src/sudoku-printer.vala"
		_g_object_unref0 (_tmp8_);
#line 45 "../src/sudoku-printer.vala"
		_g_free0 (_tmp6_);
#line 38 "../src/sudoku-printer.vala"
		_g_error_free0 (e);
#line 187 "sudoku-printer.c"
	}
	__finally5:
#line 38 "../src/sudoku-printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../src/sudoku-printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../src/sudoku-printer.vala"
		g_clear_error (&_inner_error0_);
#line 38 "../src/sudoku-printer.vala"
		return 0;
#line 198 "sudoku-printer.c"
	}
#line 51 "../src/sudoku-printer.vala"
	result = GTK_PRINT_OPERATION_RESULT_ERROR;
#line 51 "../src/sudoku-printer.vala"
	return result;
#line 204 "sudoku-printer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/sudoku-printer.vala"
	return self ? g_object_ref (self) : NULL;
#line 212 "sudoku-printer.c"
}

static void
_sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                GtkPrintContext* context,
                                                                gpointer self)
{
#line 62 "../src/sudoku-printer.vala"
	sudoku_printer_begin_print_cb ((SudokuPrinter*) self, _sender, context);
#line 222 "sudoku-printer.c"
}

static void
_sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                            GtkPrintContext* context,
                                                            gint page_nr,
                                                            gpointer self)
{
#line 63 "../src/sudoku-printer.vala"
	sudoku_printer_draw_page_cb ((SudokuPrinter*) self, _sender, context, page_nr);
#line 233 "sudoku-printer.c"
}

SudokuPrinter*
sudoku_printer_construct (GType object_type,
                          GeeList* boards,
                          GtkWindow* window)
{
	SudokuPrinter * self = NULL;
	GeeList* _tmp0_;
	GtkWindow* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPrintOperation* _tmp4_;
	GtkPrintOperation* _tmp5_;
	GtkPrintOperation* _tmp6_;
#line 54 "../src/sudoku-printer.vala"
	g_return_val_if_fail (boards != NULL, NULL);
#line 54 "../src/sudoku-printer.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 54 "../src/sudoku-printer.vala"
	self = (SudokuPrinter*) g_object_new (object_type, NULL);
#line 56 "../src/sudoku-printer.vala"
	_tmp0_ = _g_object_ref0 (boards);
#line 56 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 56 "../src/sudoku-printer.vala"
	self->priv->boards = _tmp0_;
#line 57 "../src/sudoku-printer.vala"
	_tmp1_ = _g_object_ref0 (window);
#line 57 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 57 "../src/sudoku-printer.vala"
	self->priv->window = _tmp1_;
#line 58 "../src/sudoku-printer.vala"
	self->priv->margin = 25;
#line 59 "../src/sudoku-printer.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) boards);
#line 59 "../src/sudoku-printer.vala"
	_tmp3_ = _tmp2_;
#line 59 "../src/sudoku-printer.vala"
	self->priv->n_sudokus = _tmp3_;
#line 61 "../src/sudoku-printer.vala"
	_tmp4_ = gtk_print_operation_new ();
#line 61 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 61 "../src/sudoku-printer.vala"
	self->priv->print_op = _tmp4_;
#line 62 "../src/sudoku-printer.vala"
	_tmp5_ = self->priv->print_op;
#line 62 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp5_, "begin-print", (GCallback) _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print, self, 0);
#line 63 "../src/sudoku-printer.vala"
	_tmp6_ = self->priv->print_op;
#line 63 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp6_, "draw-page", (GCallback) _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page, self, 0);
#line 54 "../src/sudoku-printer.vala"
	return self;
#line 291 "sudoku-printer.c"
}

SudokuPrinter*
sudoku_printer_new (GeeList* boards,
                    GtkWindow* window)
{
#line 54 "../src/sudoku-printer.vala"
	return sudoku_printer_construct (TYPE_SUDOKU_PRINTER, boards, window);
#line 300 "sudoku-printer.c"
}

static void
sudoku_printer_begin_print_cb (SudokuPrinter* self,
                               GtkPrintOperation* operation,
                               GtkPrintContext* context)
{
	gint pages = 0;
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 68 "../src/sudoku-printer.vala"
	pages = self->priv->n_sudokus / SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 69 "../src/sudoku-printer.vala"
	while (TRUE) {
#line 69 "../src/sudoku-printer.vala"
		if (!((pages * SUDOKU_PRINTER_SUDOKUS_PER_PAGE) < self->priv->n_sudokus)) {
#line 69 "../src/sudoku-printer.vala"
			break;
#line 323 "sudoku-printer.c"
		}
#line 70 "../src/sudoku-printer.vala"
		pages += 1;
#line 327 "sudoku-printer.c"
	}
#line 72 "../src/sudoku-printer.vala"
	gtk_print_operation_set_n_pages (operation, pages);
#line 331 "sudoku-printer.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 77 "../src/sudoku-printer.vala"
	return self ? cairo_reference (self) : NULL;
#line 339 "sudoku-printer.c"
}

static void
sudoku_printer_draw_page_cb (SudokuPrinter* self,
                             GtkPrintOperation* operation,
                             GtkPrintContext* context,
                             gint page_nr)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble width = 0.0;
	gdouble height = 0.0;
	gdouble best_square_size = 0.0;
	gint start = 0;
	gint end = 0;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeList* sudokus_on_page = NULL;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	gdouble left = 0.0;
	gdouble top = 0.0;
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 77 "../src/sudoku-printer.vala"
	_tmp0_ = gtk_print_context_get_cairo_context (context);
#line 77 "../src/sudoku-printer.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 77 "../src/sudoku-printer.vala"
	cr = _tmp1_;
#line 78 "../src/sudoku-printer.vala"
	width = gtk_print_context_get_width (context);
#line 79 "../src/sudoku-printer.vala"
	height = gtk_print_context_get_height (context);
#line 81 "../src/sudoku-printer.vala"
	best_square_size = sudoku_printer_fit_squares_in_rectangle (self, width, height, self->priv->margin);
#line 83 "../src/sudoku-printer.vala"
	start = page_nr * SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 84 "../src/sudoku-printer.vala"
	_tmp2_ = self->priv->boards;
#line 84 "../src/sudoku-printer.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 84 "../src/sudoku-printer.vala"
	_tmp4_ = _tmp3_;
#line 84 "../src/sudoku-printer.vala"
	end = MIN (start + SUDOKU_PRINTER_SUDOKUS_PER_PAGE, _tmp4_);
#line 85 "../src/sudoku-printer.vala"
	_tmp5_ = self->priv->boards;
#line 85 "../src/sudoku-printer.vala"
	_tmp6_ = gee_list_slice (_tmp5_, start, end);
#line 85 "../src/sudoku-printer.vala"
	sudokus_on_page = _tmp6_;
#line 87 "../src/sudoku-printer.vala"
	left = (width - best_square_size) / 2;
#line 88 "../src/sudoku-printer.vala"
	top = (gdouble) self->priv->margin;
#line 402 "sudoku-printer.c"
	{
		GeeList* _sudoku_list = NULL;
		GeeList* _tmp7_;
		GeeList* _tmp8_;
		gint _sudoku_size = 0;
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _sudoku_index = 0;
#line 90 "../src/sudoku-printer.vala"
		_tmp7_ = sudokus_on_page;
#line 90 "../src/sudoku-printer.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 90 "../src/sudoku-printer.vala"
		_sudoku_list = _tmp8_;
#line 90 "../src/sudoku-printer.vala"
		_tmp9_ = _sudoku_list;
#line 90 "../src/sudoku-printer.vala"
		_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 90 "../src/sudoku-printer.vala"
		_tmp11_ = _tmp10_;
#line 90 "../src/sudoku-printer.vala"
		_sudoku_size = _tmp11_;
#line 90 "../src/sudoku-printer.vala"
		_sudoku_index = -1;
#line 90 "../src/sudoku-printer.vala"
		while (TRUE) {
#line 430 "sudoku-printer.c"
			SudokuBoard* sudoku = NULL;
			GeeList* _tmp12_;
			gpointer _tmp13_;
			gchar* label = NULL;
			SudokuBoard* _tmp14_;
			DifficultyCategory _tmp15_;
			DifficultyCategory _tmp16_;
			gchar* _tmp17_;
			cairo_t* _tmp18_;
			cairo_t* _tmp19_;
			cairo_t* _tmp20_;
			cairo_text_extents_t extents = {0};
			cairo_t* _tmp21_;
			const gchar* _tmp22_;
			cairo_text_extents_t _tmp23_ = {0};
			cairo_t* _tmp24_;
			cairo_text_extents_t _tmp25_;
			cairo_text_extents_t _tmp26_;
			cairo_t* _tmp27_;
			const gchar* _tmp28_;
			cairo_t* _tmp29_;
			SudokuBoard* _tmp30_;
#line 90 "../src/sudoku-printer.vala"
			_sudoku_index = _sudoku_index + 1;
#line 90 "../src/sudoku-printer.vala"
			if (!(_sudoku_index < _sudoku_size)) {
#line 90 "../src/sudoku-printer.vala"
				break;
#line 459 "sudoku-printer.c"
			}
#line 90 "../src/sudoku-printer.vala"
			_tmp12_ = _sudoku_list;
#line 90 "../src/sudoku-printer.vala"
			_tmp13_ = gee_list_get (_tmp12_, _sudoku_index);
#line 90 "../src/sudoku-printer.vala"
			sudoku = (SudokuBoard*) _tmp13_;
#line 92 "../src/sudoku-printer.vala"
			_tmp14_ = sudoku;
#line 92 "../src/sudoku-printer.vala"
			_tmp15_ = sudoku_board_get_difficulty_category (_tmp14_);
#line 92 "../src/sudoku-printer.vala"
			_tmp16_ = _tmp15_;
#line 92 "../src/sudoku-printer.vala"
			_tmp17_ = difficulty_category_to_string (_tmp16_);
#line 92 "../src/sudoku-printer.vala"
			label = _tmp17_;
#line 93 "../src/sudoku-printer.vala"
			_tmp18_ = cr;
#line 93 "../src/sudoku-printer.vala"
			cairo_set_font_size (_tmp18_, (gdouble) 12);
#line 94 "../src/sudoku-printer.vala"
			_tmp19_ = cr;
#line 94 "../src/sudoku-printer.vala"
			cairo_select_font_face (_tmp19_, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 95 "../src/sudoku-printer.vala"
			_tmp20_ = cr;
#line 95 "../src/sudoku-printer.vala"
			cairo_set_source_rgb (_tmp20_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 97 "../src/sudoku-printer.vala"
			_tmp21_ = cr;
#line 97 "../src/sudoku-printer.vala"
			_tmp22_ = label;
#line 97 "../src/sudoku-printer.vala"
			cairo_text_extents (_tmp21_, _tmp22_, &_tmp23_);
#line 97 "../src/sudoku-printer.vala"
			extents = _tmp23_;
#line 98 "../src/sudoku-printer.vala"
			_tmp24_ = cr;
#line 98 "../src/sudoku-printer.vala"
			_tmp25_ = extents;
#line 98 "../src/sudoku-printer.vala"
			_tmp26_ = extents;
#line 98 "../src/sudoku-printer.vala"
			cairo_move_to (_tmp24_, (width - _tmp25_.width) / 2, top - (_tmp26_.height / 2));
#line 99 "../src/sudoku-printer.vala"
			_tmp27_ = cr;
#line 99 "../src/sudoku-printer.vala"
			_tmp28_ = label;
#line 99 "../src/sudoku-printer.vala"
			cairo_show_text (_tmp27_, _tmp28_);
#line 101 "../src/sudoku-printer.vala"
			_tmp29_ = cr;
#line 101 "../src/sudoku-printer.vala"
			_tmp30_ = sudoku;
#line 101 "../src/sudoku-printer.vala"
			sudoku_printer_draw_sudoku (self, _tmp29_, _tmp30_, best_square_size, left, top);
#line 103 "../src/sudoku-printer.vala"
			top += best_square_size + (2 * self->priv->margin);
#line 90 "../src/sudoku-printer.vala"
			_g_free0 (label);
#line 90 "../src/sudoku-printer.vala"
			_g_object_unref0 (sudoku);
#line 523 "sudoku-printer.c"
		}
#line 90 "../src/sudoku-printer.vala"
		_g_object_unref0 (_sudoku_list);
#line 527 "sudoku-printer.c"
	}
#line 75 "../src/sudoku-printer.vala"
	_g_object_unref0 (sudokus_on_page);
#line 75 "../src/sudoku-printer.vala"
	_cairo_destroy0 (cr);
#line 533 "sudoku-printer.c"
}

static gdouble
sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                         gdouble width,
                                         gdouble height,
                                         gint margin)
{
	gint n = 0;
	gdouble best_square_size = 0.0;
	gdouble square_size = 0.0;
	gdouble result = 0.0;
#line 107 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 109 "../src/sudoku-printer.vala"
	n = SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 110 "../src/sudoku-printer.vala"
	best_square_size = 0.0;
#line 111 "../src/sudoku-printer.vala"
	square_size = 0.0;
#line 554 "sudoku-printer.c"
	{
		gint n_across = 0;
#line 113 "../src/sudoku-printer.vala"
		n_across = 1;
#line 559 "sudoku-printer.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "../src/sudoku-printer.vala"
			_tmp0_ = TRUE;
#line 113 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 566 "sudoku-printer.c"
				gdouble n_down = 0.0;
				gdouble across_size = 0.0;
				gdouble down_size = 0.0;
#line 113 "../src/sudoku-printer.vala"
				if (!_tmp0_) {
#line 572 "sudoku-printer.c"
					gint _tmp1_;
#line 113 "../src/sudoku-printer.vala"
					_tmp1_ = n_across;
#line 113 "../src/sudoku-printer.vala"
					n_across = _tmp1_ + 1;
#line 578 "sudoku-printer.c"
				}
#line 113 "../src/sudoku-printer.vala"
				_tmp0_ = FALSE;
#line 113 "../src/sudoku-printer.vala"
				if (!(n_across <= n)) {
#line 113 "../src/sudoku-printer.vala"
					break;
#line 586 "sudoku-printer.c"
				}
#line 115 "../src/sudoku-printer.vala"
				n_down = (gdouble) (n / n_across);
#line 116 "../src/sudoku-printer.vala"
				across_size = width - ((n_across + 1) * margin);
#line 117 "../src/sudoku-printer.vala"
				across_size = across_size / n_across;
#line 118 "../src/sudoku-printer.vala"
				down_size = height - ((n_down + 1) * margin);
#line 119 "../src/sudoku-printer.vala"
				down_size = down_size / n_down;
#line 121 "../src/sudoku-printer.vala"
				square_size = MIN (across_size, down_size);
#line 122 "../src/sudoku-printer.vala"
				if (square_size > best_square_size) {
#line 123 "../src/sudoku-printer.vala"
					best_square_size = square_size;
#line 604 "sudoku-printer.c"
				}
			}
		}
	}
#line 126 "../src/sudoku-printer.vala"
	result = best_square_size;
#line 126 "../src/sudoku-printer.vala"
	return result;
#line 613 "sudoku-printer.c"
}

static void
sudoku_printer_draw_sudoku (SudokuPrinter* self,
                            cairo_t* cr,
                            SudokuBoard* sudoku_board,
                            gdouble size,
                            gdouble offset_x,
                            gdouble offset_y)
{
#line 131 "../src/sudoku-printer.vala"
	static const gint SUDOKU_SIZE = 9;
#line 132 "../src/sudoku-printer.vala"
	static const gint N_BOXES = 3;
#line 133 "../src/sudoku-printer.vala"
	static const gdouble PENCIL_GREY[3] = {0.3, 0.3, 0.3};
#line 134 "../src/sudoku-printer.vala"
	static const gdouble BACKGROUND_COLOR[3] = {1.0, 1.0, 1.0};
#line 136 "../src/sudoku-printer.vala"
	static const gdouble BORDER_COLOR[3] = {1.0, 1.0, 1.0};
#line 137 "../src/sudoku-printer.vala"
	static const gdouble LINE_COLOR[3] = {0.0, 0.0, 0.0};
#line 636 "sudoku-printer.c"
	gdouble THIN = 0.0;
	gdouble THICK = 0.0;
	gdouble BORDER = 0.0;
	gdouble WHITE_SPACE = 0.0;
	gdouble SQUARE_SIZE = 0.0;
	gint FONT_SIZE = 0;
#line 146 "../src/sudoku-printer.vala"
	static const cairo_font_weight_t FONT_WEIGHT = CAIRO_FONT_WEIGHT_NORMAL;
#line 645 "sudoku-printer.c"
	gdouble* outer = NULL;
	gdouble* _tmp0_;
	gint outer_length1;
	gint _outer_size_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	gdouble _tmp4_;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble* _tmp15_;
	gint _tmp15__length1;
	gdouble _tmp16_;
	gdouble* _tmp17_;
	gint _tmp17__length1;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble* pos = NULL;
	gdouble* _tmp22_;
	gint pos_length1;
	gint _pos_size_;
	gdouble position = 0.0;
	gdouble* _tmp23_;
	gint _tmp23__length1;
	gdouble last_line = 0.0;
	gchar* letter = NULL;
	gchar* _tmp27_;
	cairo_text_extents_t extents = {0};
	gint* sudoku = NULL;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	gint* _tmp30_;
	gint sudoku_length1;
	gint sudoku_length2;
	gboolean invert = FALSE;
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (cr != NULL);
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (sudoku_board != NULL);
#line 139 "../src/sudoku-printer.vala"
	THIN = size / 500.0;
#line 140 "../src/sudoku-printer.vala"
	THICK = THIN * 5;
#line 141 "../src/sudoku-printer.vala"
	BORDER = THICK;
#line 142 "../src/sudoku-printer.vala"
	WHITE_SPACE = (((size - (2 * BORDER)) - (2 * THICK)) - ((N_BOXES - 1) * THICK)) - ((N_BOXES * 2) * THIN);
#line 143 "../src/sudoku-printer.vala"
	SQUARE_SIZE = WHITE_SPACE / SUDOKU_SIZE;
#line 145 "../src/sudoku-printer.vala"
	FONT_SIZE = ((gint) SQUARE_SIZE) / 2;
#line 148 "../src/sudoku-printer.vala"
	_tmp0_ = g_new0 (gdouble, 4);
#line 148 "../src/sudoku-printer.vala"
	_tmp0_[0] = offset_x;
#line 148 "../src/sudoku-printer.vala"
	_tmp0_[1] = offset_x + size;
#line 148 "../src/sudoku-printer.vala"
	_tmp0_[2] = offset_y;
#line 148 "../src/sudoku-printer.vala"
	_tmp0_[3] = offset_y + size;
#line 148 "../src/sudoku-printer.vala"
	outer = _tmp0_;
#line 148 "../src/sudoku-printer.vala"
	outer_length1 = 4;
#line 148 "../src/sudoku-printer.vala"
	_outer_size_ = outer_length1;
#line 151 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, 1.0, 1.0, 1.0);
#line 152 "../src/sudoku-printer.vala"
	_tmp1_ = outer;
#line 152 "../src/sudoku-printer.vala"
	_tmp1__length1 = outer_length1;
#line 152 "../src/sudoku-printer.vala"
	_tmp2_ = _tmp1_[0];
#line 152 "../src/sudoku-printer.vala"
	_tmp3_ = outer;
#line 152 "../src/sudoku-printer.vala"
	_tmp3__length1 = outer_length1;
#line 152 "../src/sudoku-printer.vala"
	_tmp4_ = _tmp3_[2];
#line 152 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp2_, _tmp4_, size, size);
#line 153 "../src/sudoku-printer.vala"
	cairo_fill (cr);
#line 156 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 157 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, BORDER);
#line 158 "../src/sudoku-printer.vala"
	_tmp5_ = outer;
#line 158 "../src/sudoku-printer.vala"
	_tmp5__length1 = outer_length1;
#line 158 "../src/sudoku-printer.vala"
	_tmp6_ = _tmp5_[0];
#line 158 "../src/sudoku-printer.vala"
	_tmp7_ = outer;
#line 158 "../src/sudoku-printer.vala"
	_tmp7__length1 = outer_length1;
#line 158 "../src/sudoku-printer.vala"
	_tmp8_ = _tmp7_[2];
#line 158 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp6_ + (BORDER / 2.0), _tmp8_ + (BORDER / 2.0), size - BORDER, size - BORDER);
#line 161 "../src/sudoku-printer.vala"
	_tmp9_ = BACKGROUND_COLOR[0];
#line 161 "../src/sudoku-printer.vala"
	_tmp10_ = BACKGROUND_COLOR[1];
#line 161 "../src/sudoku-printer.vala"
	_tmp11_ = BACKGROUND_COLOR[2];
#line 161 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp9_, _tmp10_, _tmp11_);
#line 162 "../src/sudoku-printer.vala"
	cairo_fill_preserve (cr);
#line 164 "../src/sudoku-printer.vala"
	_tmp12_ = BORDER_COLOR[0];
#line 164 "../src/sudoku-printer.vala"
	_tmp13_ = BORDER_COLOR[1];
#line 164 "../src/sudoku-printer.vala"
	_tmp14_ = BORDER_COLOR[2];
#line 164 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp12_, _tmp13_, _tmp14_);
#line 165 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 168 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
#line 169 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, THICK);
#line 170 "../src/sudoku-printer.vala"
	_tmp15_ = outer;
#line 170 "../src/sudoku-printer.vala"
	_tmp15__length1 = outer_length1;
#line 170 "../src/sudoku-printer.vala"
	_tmp16_ = _tmp15_[0];
#line 170 "../src/sudoku-printer.vala"
	_tmp17_ = outer;
#line 170 "../src/sudoku-printer.vala"
	_tmp17__length1 = outer_length1;
#line 170 "../src/sudoku-printer.vala"
	_tmp18_ = _tmp17_[2];
#line 170 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, (_tmp16_ + BORDER) + (THICK / 2.0), (_tmp18_ + BORDER) + (THICK / 2.0), (size - (BORDER * 2)) - THICK, (size - (BORDER * 2)) - THICK);
#line 171 "../src/sudoku-printer.vala"
	_tmp19_ = LINE_COLOR[0];
#line 171 "../src/sudoku-printer.vala"
	_tmp20_ = LINE_COLOR[1];
#line 171 "../src/sudoku-printer.vala"
	_tmp21_ = LINE_COLOR[2];
#line 171 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp19_, _tmp20_, _tmp21_);
#line 172 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 174 "../src/sudoku-printer.vala"
	_tmp22_ = g_new0 (gdouble, SUDOKU_SIZE + 1);
#line 174 "../src/sudoku-printer.vala"
	pos = _tmp22_;
#line 174 "../src/sudoku-printer.vala"
	pos_length1 = SUDOKU_SIZE + 1;
#line 174 "../src/sudoku-printer.vala"
	_pos_size_ = pos_length1;
#line 175 "../src/sudoku-printer.vala"
	position = BORDER + THICK;
#line 176 "../src/sudoku-printer.vala"
	_tmp23_ = pos;
#line 176 "../src/sudoku-printer.vala"
	_tmp23__length1 = pos_length1;
#line 176 "../src/sudoku-printer.vala"
	_tmp23_[0] = position + (SQUARE_SIZE / 2.0);
#line 177 "../src/sudoku-printer.vala"
	last_line = 0.0;
#line 831 "sudoku-printer.c"
	{
		gint n = 0;
#line 179 "../src/sudoku-printer.vala"
		n = 1;
#line 836 "sudoku-printer.c"
		{
			gboolean _tmp24_ = FALSE;
#line 179 "../src/sudoku-printer.vala"
			_tmp24_ = TRUE;
#line 179 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 843 "sudoku-printer.c"
				gdouble* _tmp26_;
				gint _tmp26__length1;
#line 179 "../src/sudoku-printer.vala"
				if (!_tmp24_) {
#line 848 "sudoku-printer.c"
					gint _tmp25_;
#line 179 "../src/sudoku-printer.vala"
					_tmp25_ = n;
#line 179 "../src/sudoku-printer.vala"
					n = _tmp25_ + 1;
#line 854 "sudoku-printer.c"
				}
#line 179 "../src/sudoku-printer.vala"
				_tmp24_ = FALSE;
#line 179 "../src/sudoku-printer.vala"
				if (!(n <= SUDOKU_SIZE)) {
#line 179 "../src/sudoku-printer.vala"
					break;
#line 862 "sudoku-printer.c"
				}
#line 181 "../src/sudoku-printer.vala"
				if ((n % N_BOXES) == 0) {
#line 183 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, THICK);
#line 184 "../src/sudoku-printer.vala"
					position += (SQUARE_SIZE + (last_line / 2.0)) + (THICK / 2.0);
#line 185 "../src/sudoku-printer.vala"
					last_line = THICK;
#line 872 "sudoku-printer.c"
				} else {
#line 189 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, THIN);
#line 190 "../src/sudoku-printer.vala"
					position += (SQUARE_SIZE + (last_line / 2.0)) + (THIN / 2.0);
#line 191 "../src/sudoku-printer.vala"
					last_line = THIN;
#line 880 "sudoku-printer.c"
				}
#line 194 "../src/sudoku-printer.vala"
				_tmp26_ = pos;
#line 194 "../src/sudoku-printer.vala"
				_tmp26__length1 = pos_length1;
#line 194 "../src/sudoku-printer.vala"
				_tmp26_[n] = (position + (last_line / 2.0)) + (SQUARE_SIZE / 2.0);
#line 195 "../src/sudoku-printer.vala"
				cairo_move_to (cr, (BORDER + (THICK / 2.0)) + offset_x, position + offset_y);
#line 196 "../src/sudoku-printer.vala"
				cairo_line_to (cr, ((size - BORDER) - (THICK / 2.0)) + offset_x, position + offset_y);
#line 197 "../src/sudoku-printer.vala"
				cairo_move_to (cr, position + offset_x, (BORDER + (THICK / 2.0)) + offset_y);
#line 198 "../src/sudoku-printer.vala"
				cairo_line_to (cr, position + offset_x, ((size - BORDER) - (THICK / 2.0)) + offset_y);
#line 199 "../src/sudoku-printer.vala"
				cairo_stroke (cr);
#line 898 "sudoku-printer.c"
			}
		}
	}
#line 202 "../src/sudoku-printer.vala"
	cairo_set_font_size (cr, (gdouble) FONT_SIZE);
#line 203 "../src/sudoku-printer.vala"
	_tmp27_ = g_strdup ("");
#line 203 "../src/sudoku-printer.vala"
	letter = _tmp27_;
#line 205 "../src/sudoku-printer.vala"
	_tmp30_ = sudoku_board_get_cells (sudoku_board, &_tmp28_, &_tmp29_);
#line 205 "../src/sudoku-printer.vala"
	sudoku = _tmp30_;
#line 205 "../src/sudoku-printer.vala"
	sudoku_length1 = _tmp28_;
#line 205 "../src/sudoku-printer.vala"
	sudoku_length2 = _tmp29_;
#line 207 "../src/sudoku-printer.vala"
	invert = gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL;
#line 918 "sudoku-printer.c"
	{
		gint x = 0;
#line 209 "../src/sudoku-printer.vala"
		x = 0;
#line 923 "sudoku-printer.c"
		{
			gboolean _tmp31_ = FALSE;
#line 209 "../src/sudoku-printer.vala"
			_tmp31_ = TRUE;
#line 209 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 930 "sudoku-printer.c"
				gint _tmp33_ = 0;
				gint real_x = 0;
#line 209 "../src/sudoku-printer.vala"
				if (!_tmp31_) {
#line 935 "sudoku-printer.c"
					gint _tmp32_;
#line 209 "../src/sudoku-printer.vala"
					_tmp32_ = x;
#line 209 "../src/sudoku-printer.vala"
					x = _tmp32_ + 1;
#line 941 "sudoku-printer.c"
				}
#line 209 "../src/sudoku-printer.vala"
				_tmp31_ = FALSE;
#line 209 "../src/sudoku-printer.vala"
				if (!(x < SUDOKU_SIZE)) {
#line 209 "../src/sudoku-printer.vala"
					break;
#line 949 "sudoku-printer.c"
				}
#line 211 "../src/sudoku-printer.vala"
				if (invert) {
#line 211 "../src/sudoku-printer.vala"
					_tmp33_ = (SUDOKU_SIZE - x) - 1;
#line 955 "sudoku-printer.c"
				} else {
#line 211 "../src/sudoku-printer.vala"
					_tmp33_ = x;
#line 959 "sudoku-printer.c"
				}
#line 211 "../src/sudoku-printer.vala"
				real_x = _tmp33_;
#line 963 "sudoku-printer.c"
				{
					gint y = 0;
#line 212 "../src/sudoku-printer.vala"
					y = 0;
#line 968 "sudoku-printer.c"
					{
						gboolean _tmp34_ = FALSE;
#line 212 "../src/sudoku-printer.vala"
						_tmp34_ = TRUE;
#line 212 "../src/sudoku-printer.vala"
						while (TRUE) {
#line 975 "sudoku-printer.c"
							gdouble* _tmp36_;
							gint _tmp36__length1;
							gdouble _tmp37_;
							gdouble* _tmp38_;
							gint _tmp38__length1;
							gdouble _tmp39_;
							gchar* _tmp40_;
							gint* _tmp41_;
							gint _tmp41__length1;
							gint _tmp41__length2;
							gint _tmp42_;
#line 212 "../src/sudoku-printer.vala"
							if (!_tmp34_) {
#line 989 "sudoku-printer.c"
								gint _tmp35_;
#line 212 "../src/sudoku-printer.vala"
								_tmp35_ = y;
#line 212 "../src/sudoku-printer.vala"
								y = _tmp35_ + 1;
#line 995 "sudoku-printer.c"
							}
#line 212 "../src/sudoku-printer.vala"
							_tmp34_ = FALSE;
#line 212 "../src/sudoku-printer.vala"
							if (!(y < SUDOKU_SIZE)) {
#line 212 "../src/sudoku-printer.vala"
								break;
#line 1003 "sudoku-printer.c"
							}
#line 214 "../src/sudoku-printer.vala"
							_tmp36_ = pos;
#line 214 "../src/sudoku-printer.vala"
							_tmp36__length1 = pos_length1;
#line 214 "../src/sudoku-printer.vala"
							_tmp37_ = _tmp36_[x];
#line 214 "../src/sudoku-printer.vala"
							_tmp38_ = pos;
#line 214 "../src/sudoku-printer.vala"
							_tmp38__length1 = pos_length1;
#line 214 "../src/sudoku-printer.vala"
							_tmp39_ = _tmp38_[y];
#line 214 "../src/sudoku-printer.vala"
							cairo_move_to (cr, _tmp37_ + offset_x, _tmp39_ + offset_y);
#line 215 "../src/sudoku-printer.vala"
							_tmp40_ = g_strdup ("");
#line 215 "../src/sudoku-printer.vala"
							_g_free0 (letter);
#line 215 "../src/sudoku-printer.vala"
							letter = _tmp40_;
#line 217 "../src/sudoku-printer.vala"
							_tmp41_ = sudoku;
#line 217 "../src/sudoku-printer.vala"
							_tmp41__length1 = sudoku_length1;
#line 217 "../src/sudoku-printer.vala"
							_tmp41__length2 = sudoku_length2;
#line 217 "../src/sudoku-printer.vala"
							_tmp42_ = _tmp41_[(y * _tmp41__length2) + real_x];
#line 217 "../src/sudoku-printer.vala"
							if (_tmp42_ != 0) {
#line 1035 "sudoku-printer.c"
								gint* _tmp43_;
								gint _tmp43__length1;
								gint _tmp43__length2;
								gint _tmp44_;
								gchar* _tmp45_;
								gboolean* _tmp46_;
								gint _tmp46__length1;
								gint _tmp46__length2;
								gboolean _tmp47_;
								const gchar* _tmp51_;
								cairo_text_extents_t _tmp52_ = {0};
								gdouble* _tmp53_;
								gint _tmp53__length1;
								gdouble _tmp54_;
								cairo_text_extents_t _tmp55_;
								gdouble* _tmp56_;
								gint _tmp56__length1;
								gdouble _tmp57_;
								cairo_text_extents_t _tmp58_;
								const gchar* _tmp59_;
#line 219 "../src/sudoku-printer.vala"
								_tmp43_ = sudoku;
#line 219 "../src/sudoku-printer.vala"
								_tmp43__length1 = sudoku_length1;
#line 219 "../src/sudoku-printer.vala"
								_tmp43__length2 = sudoku_length2;
#line 219 "../src/sudoku-printer.vala"
								_tmp44_ = _tmp43_[(y * _tmp43__length2) + real_x];
#line 219 "../src/sudoku-printer.vala"
								_tmp45_ = g_strdup_printf ("%i", _tmp44_);
#line 219 "../src/sudoku-printer.vala"
								_g_free0 (letter);
#line 219 "../src/sudoku-printer.vala"
								letter = _tmp45_;
#line 221 "../src/sudoku-printer.vala"
								_tmp46_ = sudoku_board->is_fixed;
#line 221 "../src/sudoku-printer.vala"
								_tmp46__length1 = sudoku_board->is_fixed_length1;
#line 221 "../src/sudoku-printer.vala"
								_tmp46__length2 = sudoku_board->is_fixed_length2;
#line 221 "../src/sudoku-printer.vala"
								_tmp47_ = _tmp46_[(y * _tmp46__length2) + real_x];
#line 221 "../src/sudoku-printer.vala"
								if (_tmp47_) {
#line 223 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_NORMAL, FONT_WEIGHT);
#line 224 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 1084 "sudoku-printer.c"
								} else {
									gdouble _tmp48_;
									gdouble _tmp49_;
									gdouble _tmp50_;
#line 228 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_ITALIC, FONT_WEIGHT);
#line 229 "../src/sudoku-printer.vala"
									_tmp48_ = PENCIL_GREY[0];
#line 229 "../src/sudoku-printer.vala"
									_tmp49_ = PENCIL_GREY[1];
#line 229 "../src/sudoku-printer.vala"
									_tmp50_ = PENCIL_GREY[2];
#line 229 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, _tmp48_, _tmp49_, _tmp50_);
#line 1099 "sudoku-printer.c"
								}
#line 231 "../src/sudoku-printer.vala"
								_tmp51_ = letter;
#line 231 "../src/sudoku-printer.vala"
								cairo_text_extents (cr, _tmp51_, &_tmp52_);
#line 231 "../src/sudoku-printer.vala"
								extents = _tmp52_;
#line 232 "../src/sudoku-printer.vala"
								_tmp53_ = pos;
#line 232 "../src/sudoku-printer.vala"
								_tmp53__length1 = pos_length1;
#line 232 "../src/sudoku-printer.vala"
								_tmp54_ = _tmp53_[x];
#line 232 "../src/sudoku-printer.vala"
								_tmp55_ = extents;
#line 232 "../src/sudoku-printer.vala"
								_tmp56_ = pos;
#line 232 "../src/sudoku-printer.vala"
								_tmp56__length1 = pos_length1;
#line 232 "../src/sudoku-printer.vala"
								_tmp57_ = _tmp56_[y];
#line 232 "../src/sudoku-printer.vala"
								_tmp58_ = extents;
#line 232 "../src/sudoku-printer.vala"
								cairo_move_to (cr, (_tmp54_ + offset_x) - (_tmp55_.x_advance / 2.0), (_tmp57_ + offset_y) + (_tmp58_.height / 2.0));
#line 233 "../src/sudoku-printer.vala"
								_tmp59_ = letter;
#line 233 "../src/sudoku-printer.vala"
								cairo_show_text (cr, _tmp59_);
#line 1129 "sudoku-printer.c"
							}
						}
					}
				}
			}
		}
	}
#line 129 "../src/sudoku-printer.vala"
	sudoku = (g_free (sudoku), NULL);
#line 129 "../src/sudoku-printer.vala"
	_g_free0 (letter);
#line 129 "../src/sudoku-printer.vala"
	pos = (g_free (pos), NULL);
#line 129 "../src/sudoku-printer.vala"
	outer = (g_free (outer), NULL);
#line 1145 "sudoku-printer.c"
}

static void
sudoku_printer_class_init (SudokuPrinterClass * klass,
                           gpointer klass_data)
{
#line 25 "../src/sudoku-printer.vala"
	sudoku_printer_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/sudoku-printer.vala"
	g_type_class_adjust_private_offset (klass, &SudokuPrinter_private_offset);
#line 25 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_printer_finalize;
#line 1158 "sudoku-printer.c"
}

static void
sudoku_printer_instance_init (SudokuPrinter * self,
                              gpointer klass)
{
#line 25 "../src/sudoku-printer.vala"
	self->priv = sudoku_printer_get_instance_private (self);
#line 1167 "sudoku-printer.c"
}

static void
sudoku_printer_finalize (GObject * obj)
{
	SudokuPrinter * self;
#line 25 "../src/sudoku-printer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PRINTER, SudokuPrinter);
#line 27 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 28 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 34 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 25 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (sudoku_printer_parent_class)->finalize (obj);
#line 1184 "sudoku-printer.c"
}

GType
sudoku_printer_get_type (void)
{
	static volatile gsize sudoku_printer_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_printer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuPrinterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_printer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPrinter), 0, (GInstanceInitFunc) sudoku_printer_instance_init, NULL };
		GType sudoku_printer_type_id;
		sudoku_printer_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuPrinter", &g_define_type_info, 0);
		SudokuPrinter_private_offset = g_type_add_instance_private (sudoku_printer_type_id, sizeof (SudokuPrinterPrivate));
		g_once_init_leave (&sudoku_printer_type_id__volatile, sudoku_printer_type_id);
	}
	return sudoku_printer_type_id__volatile;
}

